/* ui.c generated by valac 0.46.5, the Vala compiler
 * generated from ui.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include "shotwell-plugin-dev-1.0.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>

typedef enum  {
	ADJUSTMENT_RELATION_BELOW,
	ADJUSTMENT_RELATION_IN_RANGE,
	ADJUSTMENT_RELATION_ABOVE
} AdjustmentRelation;

#define TYPE_ADJUSTMENT_RELATION (adjustment_relation_get_type ())
typedef enum  {
	COMPASS_POINT_NORTH,
	COMPASS_POINT_SOUTH,
	COMPASS_POINT_EAST,
	COMPASS_POINT_WEST
} CompassPoint;

#define TYPE_COMPASS_POINT (compass_point_get_type ())
typedef enum  {
	DIRECTION_FORWARD,
	DIRECTION_BACKWARD
} Direction;

#define TYPE_DIRECTION (direction_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

GType adjustment_relation_get_type (void) G_GNUC_CONST;
GType compass_point_get_type (void) G_GNUC_CONST;
GType direction_get_type (void) G_GNUC_CONST;
SpitTransitionsDirection direction_to_transition_direction (Direction self);
void spin_event_loop (void);
AdjustmentRelation get_adjustment_relation (GtkAdjustment* adjustment,
                                            gint value);
void get_adjustment_page (GtkAdjustment* hadj,
                          GtkAdjustment* vadj,
                          GdkRectangle* result);
gboolean has_only_key_modifier (GdkModifierType field,
                                GdkModifierType mask);
gboolean is_pointer_over (GdkWindow* window);

GType
adjustment_relation_get_type (void)
{
	static volatile gsize adjustment_relation_type_id__volatile = 0;
	if (g_once_init_enter (&adjustment_relation_type_id__volatile)) {
		static const GEnumValue values[] = {{ADJUSTMENT_RELATION_BELOW, "ADJUSTMENT_RELATION_BELOW", "below"}, {ADJUSTMENT_RELATION_IN_RANGE, "ADJUSTMENT_RELATION_IN_RANGE", "in-range"}, {ADJUSTMENT_RELATION_ABOVE, "ADJUSTMENT_RELATION_ABOVE", "above"}, {0, NULL, NULL}};
		GType adjustment_relation_type_id;
		adjustment_relation_type_id = g_enum_register_static ("AdjustmentRelation", values);
		g_once_init_leave (&adjustment_relation_type_id__volatile, adjustment_relation_type_id);
	}
	return adjustment_relation_type_id__volatile;
}

GType
compass_point_get_type (void)
{
	static volatile gsize compass_point_type_id__volatile = 0;
	if (g_once_init_enter (&compass_point_type_id__volatile)) {
		static const GEnumValue values[] = {{COMPASS_POINT_NORTH, "COMPASS_POINT_NORTH", "north"}, {COMPASS_POINT_SOUTH, "COMPASS_POINT_SOUTH", "south"}, {COMPASS_POINT_EAST, "COMPASS_POINT_EAST", "east"}, {COMPASS_POINT_WEST, "COMPASS_POINT_WEST", "west"}, {0, NULL, NULL}};
		GType compass_point_type_id;
		compass_point_type_id = g_enum_register_static ("CompassPoint", values);
		g_once_init_leave (&compass_point_type_id__volatile, compass_point_type_id);
	}
	return compass_point_type_id__volatile;
}

SpitTransitionsDirection
direction_to_transition_direction (Direction self)
{
	SpitTransitionsDirection result = 0;
	switch (self) {
		case DIRECTION_FORWARD:
		{
			result = SPIT_TRANSITIONS_DIRECTION_FORWARD;
			return result;
		}
		case DIRECTION_BACKWARD:
		{
			result = SPIT_TRANSITIONS_DIRECTION_BACKWARD;
			return result;
		}
		default:
		{
			GEnumValue* _tmp0_;
			_tmp0_ = g_enum_get_value (g_type_class_ref (TYPE_DIRECTION), self);
			g_error ("ui.vala:33: Unknown Direction %s", (_tmp0_ != NULL) ? _tmp0_->value_name : NULL);
		}
	}
}

GType
direction_get_type (void)
{
	static volatile gsize direction_type_id__volatile = 0;
	if (g_once_init_enter (&direction_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTION_FORWARD, "DIRECTION_FORWARD", "forward"}, {DIRECTION_BACKWARD, "DIRECTION_BACKWARD", "backward"}, {0, NULL, NULL}};
		GType direction_type_id;
		direction_type_id = g_enum_register_static ("Direction", values);
		g_once_init_leave (&direction_type_id__volatile, direction_type_id);
	}
	return direction_type_id__volatile;
}

void
spin_event_loop (void)
{
	while (TRUE) {
		if (!gtk_events_pending ()) {
			break;
		}
		gtk_main_iteration ();
	}
}

AdjustmentRelation
get_adjustment_relation (GtkAdjustment* adjustment,
                         gint value)
{
	AdjustmentRelation result = 0;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (adjustment, gtk_adjustment_get_type ()), 0);
	if (value < ((gint) gtk_adjustment_get_value (adjustment))) {
		result = ADJUSTMENT_RELATION_BELOW;
		return result;
	} else {
		if (value > ((gint) (gtk_adjustment_get_value (adjustment) + gtk_adjustment_get_page_size (adjustment)))) {
			result = ADJUSTMENT_RELATION_ABOVE;
			return result;
		} else {
			result = ADJUSTMENT_RELATION_IN_RANGE;
			return result;
		}
	}
}

void
get_adjustment_page (GtkAdjustment* hadj,
                     GtkAdjustment* vadj,
                     GdkRectangle* result)
{
	GdkRectangle rect = {0};
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (hadj, gtk_adjustment_get_type ()));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (vadj, gtk_adjustment_get_type ()));
	memset (&rect, 0, sizeof (GdkRectangle));
	rect.x = (gint) gtk_adjustment_get_value (hadj);
	rect.y = (gint) gtk_adjustment_get_value (vadj);
	rect.width = (gint) gtk_adjustment_get_page_size (hadj);
	rect.height = (gint) gtk_adjustment_get_page_size (vadj);
	*result = rect;
	return;
}

gboolean
has_only_key_modifier (GdkModifierType field,
                       GdkModifierType mask)
{
	gboolean result = FALSE;
	result = (field & ((((((((GDK_SHIFT_MASK | GDK_CONTROL_MASK) | GDK_MOD1_MASK) | GDK_MOD3_MASK) | GDK_MOD4_MASK) | GDK_MOD5_MASK) | GDK_SUPER_MASK) | GDK_HYPER_MASK) | GDK_META_MASK)) == mask;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

gboolean
is_pointer_over (GdkWindow* window)
{
	GdkDeviceManager* devmgr = NULL;
	GdkDisplay* _tmp0_;
	GdkDeviceManager* _tmp1_;
	GdkDeviceManager* _tmp2_;
	GdkDeviceManager* _tmp3_;
	gint x = 0;
	gint y = 0;
	GdkDeviceManager* _tmp4_;
	GdkDevice* _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (window, gdk_window_get_type ()), FALSE);
	_tmp0_ = gdk_window_get_display (window);
	_tmp1_ = gdk_display_get_device_manager (_tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	devmgr = _tmp2_;
	_tmp3_ = devmgr;
	if (_tmp3_ == NULL) {
		g_debug ("ui.vala:93: No device for display");
		result = FALSE;
		_g_object_unref0 (devmgr);
		return result;
	}
	_tmp4_ = devmgr;
	_tmp5_ = gdk_device_manager_get_client_pointer (_tmp4_);
	gdk_device_get_position (_tmp5_, NULL, &_tmp6_, &_tmp7_);
	x = _tmp6_;
	y = _tmp7_;
	if (x >= 0) {
		_tmp10_ = y >= 0;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		_tmp9_ = x < gdk_window_get_width (window);
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		_tmp8_ = y < gdk_window_get_height (window);
	} else {
		_tmp8_ = FALSE;
	}
	result = _tmp8_;
	_g_object_unref0 (devmgr);
	return result;
}

