/* VideoSupport.c generated by valac 0.46.5, the Vala compiler
 * generated from VideoSupport.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <gobject/gvaluecollector.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gst/pbutils/pbutils.h>
#include <gst/gst.h>
#include <signal.h>
#include <sys/types.h>
#include <gio/gunixinputstream.h>
#include <sys/wait.h>
#include <glib/gstdio.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>

#define TYPE_VIDEO_IMPORT_PARAMS (video_import_params_get_type ())
#define VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams))
#define VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))
#define IS_VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_IMPORT_PARAMS))
#define IS_VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_IMPORT_PARAMS))
#define VIDEO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))

typedef struct _VideoImportParams VideoImportParams;
typedef struct _VideoImportParamsClass VideoImportParamsClass;
typedef struct _VideoImportParamsPrivate VideoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _video_row_unref0(var) ((var == NULL) ? NULL : (var = (video_row_unref (var), NULL)))
typedef struct _ParamSpecVideoImportParams ParamSpecVideoImportParams;

#define TYPE_VIDEO_READER (video_reader_get_type ())
#define VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_READER, VideoReader))
#define VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_READER, VideoReaderClass))
#define IS_VIDEO_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_READER))
#define IS_VIDEO_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_READER))
#define VIDEO_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_READER, VideoReaderClass))

typedef struct _VideoReader VideoReader;
typedef struct _VideoReaderClass VideoReaderClass;
typedef struct _VideoReaderPrivate VideoReaderPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _video_reader_unref0(var) ((var == NULL) ? NULL : (var = (video_reader_unref (var), NULL)))

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_VIDEO_METADATA (video_metadata_get_type ())
#define VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_METADATA, VideoMetadata))
#define VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_METADATA, VideoMetadataClass))
#define IS_VIDEO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_METADATA))
#define IS_VIDEO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_METADATA))
#define VIDEO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_METADATA, VideoMetadataClass))

typedef struct _VideoMetadata VideoMetadata;
typedef struct _VideoMetadataClass VideoMetadataClass;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _VideoRowPrivate VideoRowPrivate;

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
typedef struct _ParamSpecVideoReader ParamSpecVideoReader;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_VIDEO_SOURCE (video_source_get_type ())
#define VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE, VideoSource))
#define VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE, VideoSourceClass))
#define IS_VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE))
#define IS_VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE))
#define VIDEO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE, VideoSourceClass))

typedef struct _VideoSource VideoSource;
typedef struct _VideoSourceClass VideoSourceClass;
typedef struct _VideoSourcePrivate VideoSourcePrivate;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_VIDEO (video_get_type ())
#define VIDEO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO, Video))
#define VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO, VideoClass))
#define IS_VIDEO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO))
#define IS_VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO))
#define VIDEO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO, VideoClass))

typedef struct _Video Video;
typedef struct _VideoClass VideoClass;
typedef struct _VideoPrivate VideoPrivate;
enum  {
	VIDEO_0_PROPERTY,
	VIDEO_NUM_PROPERTIES
};
static GParamSpec* video_properties[VIDEO_NUM_PROPERTIES];

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_VIDEO_SOURCE_COLLECTION (video_source_collection_get_type ())
#define VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection))
#define VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))
#define IS_VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE_COLLECTION))
#define IS_VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE_COLLECTION))
#define VIDEO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))

typedef struct _VideoSourceCollection VideoSourceCollection;
typedef struct _VideoSourceCollectionClass VideoSourceCollectionClass;
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_EXPORTER (exporter_get_type ())
#define EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER, Exporter))
#define EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER, ExporterClass))
#define IS_EXPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER))
#define IS_EXPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER))
#define EXPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER, ExporterClass))

typedef struct _Exporter Exporter;
typedef struct _ExporterClass ExporterClass;
typedef void (*ExporterCompletionCallback) (Exporter* exporter, gboolean is_cancelled, gpointer user_data);

#define TYPE_EXPORTER_UI (exporter_ui_get_type ())
#define EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXPORTER_UI, ExporterUI))
#define EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXPORTER_UI, ExporterUIClass))
#define IS_EXPORTER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXPORTER_UI))
#define IS_EXPORTER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXPORTER_UI))
#define EXPORTER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXPORTER_UI, ExporterUIClass))

typedef struct _ExporterUI ExporterUI;
typedef struct _ExporterUIClass ExporterUIClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;
typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())
#define _exporter_ui_unref0(var) ((var == NULL) ? NULL : (var = (exporter_ui_unref (var), NULL)))

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;
#define _backing_file_state_unref0(var) ((var == NULL) ? NULL : (var = (backing_file_state_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define VIDEO_TYPE_INTERPRETABLE_RESULTS (video_interpretable_results_get_type ())
#define VIDEO_INTERPRETABLE_RESULTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResults))
#define VIDEO_INTERPRETABLE_RESULTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResultsClass))
#define VIDEO_IS_INTERPRETABLE_RESULTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIDEO_TYPE_INTERPRETABLE_RESULTS))
#define VIDEO_IS_INTERPRETABLE_RESULTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIDEO_TYPE_INTERPRETABLE_RESULTS))
#define VIDEO_INTERPRETABLE_RESULTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResultsClass))

typedef struct _VideoInterpretableResults VideoInterpretableResults;
typedef struct _VideoInterpretableResultsClass VideoInterpretableResultsClass;
#define _video_interpretable_results_unref0(var) ((var == NULL) ? NULL : (var = (video_interpretable_results_unref (var), NULL)))
typedef struct _VideoInterpretableResultsPrivate VideoInterpretableResultsPrivate;
typedef struct _VideoParamSpecInterpretableResults VideoParamSpecInterpretableResults;
typedef struct _DataCollectionPrivate DataCollectionPrivate;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
typedef struct _VideoSourceCollectionPrivate VideoSourceCollectionPrivate;
typedef enum  {
	VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN,
	VIDEO_SOURCE_COLLECTION_STATE_ONLINE,
	VIDEO_SOURCE_COLLECTION_STATE_OFFLINE,
	VIDEO_SOURCE_COLLECTION_STATE_TRASH
} VideoSourceCollectionState;

#define VIDEO_SOURCE_COLLECTION_TYPE_STATE (video_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, gpointer user_data);
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, gpointer user_data);

#define TYPE_VIDEO_MONITOR (video_monitor_get_type ())
#define VIDEO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_MONITOR, VideoMonitor))
#define VIDEO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_MONITOR, VideoMonitorClass))
#define IS_VIDEO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_MONITOR))
#define IS_VIDEO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_MONITOR))
#define VIDEO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_MONITOR, VideoMonitorClass))

typedef struct _VideoMonitor VideoMonitor;
typedef struct _VideoMonitorClass VideoMonitorClass;

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	VIDEO_ERROR_FILE,
	VIDEO_ERROR_CONTENTS
} VideoError;
#define VIDEO_ERROR video_error_quark ()
struct _ImportID {
	gint64 id;
};

struct _VideoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	gchar* md5;
	time_t exposure_time_override;
	Thumbnails* thumbnails;
	VideoRow* row;
};

struct _VideoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoImportParams *self);
};

struct _ParamSpecVideoImportParams {
	GParamSpec parent_instance;
};

struct _VideoReader {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoReaderPrivate * priv;
};

struct _VideoReaderClass {
	GTypeClass parent_class;
	void (*finalize) (VideoReader *self);
};

struct _VideoReaderPrivate {
	gdouble clip_duration;
	GdkPixbuf* preview_frame;
	GFile* file;
	GPid thumbnailer_pid;
	GDateTime* _timestamp;
};

struct _VideoID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

struct _VideoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoRowPrivate * priv;
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
	gchar* comment;
};

struct _VideoRowClass {
	GTypeClass parent_class;
	void (*finalize) (VideoRow *self);
};

struct _ParamSpecVideoReader {
	GParamSpec parent_instance;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, gint* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _VideoSource {
	MediaSource parent_instance;
	VideoSourcePrivate * priv;
};

struct _VideoSourceClass {
	MediaSourceClass parent_class;
};

struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

struct _Video {
	VideoSource parent_instance;
	VideoPrivate * priv;
};

struct _VideoClass {
	VideoSourceClass parent_class;
};

struct _VideoPrivate {
	VideoRow* backing_row;
	GRecMutex __lock_backing_row;
};

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _VideoInterpretableResults {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoInterpretableResultsPrivate * priv;
	Video* video;
	gboolean update_interpretable;
	gboolean is_interpretable;
	GdkPixbuf* new_thumbnail;
};

struct _VideoInterpretableResultsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoInterpretableResults *self);
};

struct _VideoParamSpecInterpretableResults {
	GParamSpec parent_instance;
};

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _VideoSourceCollection {
	MediaSourceCollection parent_instance;
	VideoSourceCollectionPrivate * priv;
};

struct _VideoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
};

struct _VideoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeMultiMap* filesize_to_video;
};

static gpointer video_import_params_parent_class = NULL;
static gint VideoReader_private_offset;
static gpointer video_reader_parent_class = NULL;
static gint Video_private_offset;
static gpointer video_parent_class = NULL;
static gboolean video_interpreter_state_changed;
static gboolean video_interpreter_state_changed = FALSE;
static gint video_current_state;
static gint video_current_state = 0;
static gboolean video_normal_regen_complete;
static gboolean video_normal_regen_complete = FALSE;
static gboolean video_offline_regen_complete;
static gboolean video_offline_regen_complete = FALSE;
extern VideoSourceCollection* video_global;
VideoSourceCollection* video_global = NULL;
static gpointer video_interpretable_results_parent_class = NULL;
static FlaggableIface * video_flaggable_parent_iface = NULL;
static MonitorableIface * video_monitorable_parent_iface = NULL;
static DateableIface * video_dateable_parent_iface = NULL;
static gint VideoSourceCollection_private_offset;
static gpointer video_source_collection_parent_class = NULL;

GQuark video_error_quark (void);
gpointer video_import_params_ref (gpointer instance);
void video_import_params_unref (gpointer instance);
GParamSpec* param_spec_video_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_video_import_params (GValue* value,
                                    gpointer v_object);
void value_take_video_import_params (GValue* value,
                                     gpointer v_object);
gpointer value_get_video_import_params (const GValue* value);
GType video_import_params_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoImportParams, video_import_params_unref)
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_thumbnails (GValue* value,
                           gpointer v_object);
void value_take_thumbnails (GValue* value,
                            gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnails, thumbnails_unref)
gpointer video_row_ref (gpointer instance);
void video_row_unref (gpointer instance);
GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
void value_set_video_row (GValue* value,
                          gpointer v_object);
void value_take_video_row (GValue* value,
                           gpointer v_object);
gpointer value_get_video_row (const GValue* value);
GType video_row_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoRow, video_row_unref)
#define IMPORT_ID_INVALID ((gint64) 0)
void import_id_init (ImportID *self,
                     gint64 id);
VideoRow* video_row_new (void);
VideoRow* video_row_construct (GType object_type);
VideoImportParams* video_import_params_new (GFile* file,
                                            ImportID* import_id,
                                            const gchar* md5,
                                            Thumbnails* thumbnails,
                                            time_t exposure_time_override);
VideoImportParams* video_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id,
                                                  const gchar* md5,
                                                  Thumbnails* thumbnails,
                                                  time_t exposure_time_override);
static void video_import_params_finalize (VideoImportParams * obj);
gpointer video_reader_ref (gpointer instance);
void video_reader_unref (gpointer instance);
GParamSpec* param_spec_video_reader (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_video_reader (GValue* value,
                             gpointer v_object);
void value_take_video_reader (GValue* value,
                              gpointer v_object);
gpointer value_get_video_reader (const GValue* value);
GType video_reader_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoReader, video_reader_unref)
#define VIDEO_READER_UNKNOWN_CLIP_DURATION (-1.0)
#define VIDEO_READER_THUMBNAILER_TIMEOUT ((guint) 10000)
VideoReader* video_reader_new (GFile* file);
VideoReader* video_reader_construct (GType object_type,
                                     GFile* file);
gboolean video_reader_is_supported_video_file (GFile* file);
gboolean video_reader_is_supported_video_filename (const gchar* filename);
void disassemble_filename (const gchar* basename,
                           gchar* * name,
                           gchar* * ext);
gint utf8_ci_compare (void* a,
                      void* b);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult video_reader_prepare_for_import (VideoImportParams* params);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
GdkPixbuf* video_reader_read_preview_frame (VideoReader* self);
gdouble video_reader_read_clip_duration (VideoReader* self,
                                         GError** error);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaMetadata, media_metadata_unref)
GType video_metadata_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoMetadata, media_metadata_unref)
VideoMetadata* video_reader_read_metadata (VideoReader* self,
                                           GError** error);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MetadataDateTime, metadata_date_time_unref)
MetadataDateTime* media_metadata_get_creation_date_time (MediaMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GDateTime* video_reader_get_timestamp (VideoReader* self);
GType video_id_get_type (void) G_GNUC_CONST;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType rating_get_type (void) G_GNUC_CONST;
#define VIDEO_ID_INVALID ((gint64) -1)
void video_id_init (VideoID *self,
                    gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self,
                    gint64 id);
Thumbnails* thumbnails_new (void);
Thumbnails* thumbnails_construct (GType object_type);
void thumbnail_cache_generate_for_video_frame (Thumbnails* thumbnails,
                                               GdkPixbuf* preview_frame);
static void video_reader_read_internal (VideoReader* self,
                                 GError** error);
static gboolean video_reader_does_file_exist (VideoReader* self);
static GDate* _g_date_dup (GDate* self);
static void video_reader_set_timestamp (VideoReader* self,
                                 GDateTime* value);
static gboolean video_reader_on_thumbnailer_timer (VideoReader* self);
static GdkPixbuf* video_reader_thumbnailer (VideoReader* self,
                                     const gchar* video_file);
GFile* app_dirs_get_thumbnailer_bin (void);
static gboolean _video_reader_on_thumbnailer_timer_gsource_func (gpointer self);
GdkPixbuf* resources_get_noninterpretable_badge_pixbuf (void);
VideoMetadata* video_metadata_new (void);
VideoMetadata* video_metadata_construct (GType object_type);
void media_metadata_read_from_file (MediaMetadata* self,
                                    GFile* file,
                                    GError** error);
static void video_reader_finalize (VideoReader * obj);
GType data_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_alteration (GValue* value,
                           gpointer v_object);
void value_take_alteration (GValue* value,
                            gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_data_collection (GValue* value,
                                gpointer v_object);
void value_take_data_collection (GValue* value,
                                 gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
GType data_source_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceHoldingTank, source_holding_tank_unref)
GType source_collection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_snapshot (GValue* value,
                                gpointer v_object);
void value_take_source_snapshot (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceSnapshot, source_snapshot_unref)
GType thumbnail_source_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_backing_file_state (GValue* value,
                                   gpointer v_object);
void value_take_backing_file_state (GValue* value,
                                    gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingFileState, backing_file_state_unref)
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType video_source_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoSource, g_object_unref)
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType video_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Video, g_object_unref)
GType database_source_collection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceCollection, data_collection_unref)
GType media_source_collection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceCollection, data_collection_unref)
GType video_source_collection_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoSourceCollection, data_collection_unref)
#define VIDEO_TYPENAME "video"
#define VIDEO_FLAG_TRASH ((guint64) 0x0000000000000001)
#define VIDEO_FLAG_OFFLINE ((guint64) 0x0000000000000002)
#define VIDEO_FLAG_FLAGGED ((guint64) 0x0000000000000004)
Video* video_new (VideoRow* row);
Video* video_construct (GType object_type,
                        VideoRow* row);
VideoSource* video_source_construct (GType object_type);
gchar* media_source_prep_title (const gchar* title);
void data_source_rehydrate_backlinks (DataSource* self,
                                      SourceCollection* unlinked_from,
                                      const gchar* dehydrated);
void video_init (ProgressMonitor monitor,
                 gpointer monitor_target);
GType configuration_facade_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigurationFacade, g_object_unref)
GType config_facade_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigFacade, g_object_unref)
ConfigFacade* config_facade_get_instance (void);
gint configuration_facade_get_video_interpreter_state_cookie (ConfigurationFacade* self);
#define CONFIG_FACADE_NO_VIDEO_INTERPRETER_STATE -1
static gboolean __lambda12_ (GstPluginFeature* f);
static gboolean ___lambda12__gst_plugin_feature_filter (GstPluginFeature* feature,
                                                 gpointer self);
VideoSourceCollection* video_source_collection_new (void);
VideoSourceCollection* video_source_collection_construct (GType object_type);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_database_table (GValue* value,
                               gpointer v_object);
void value_take_database_table (GValue* value,
                                gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
GType video_table_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoTable, database_table_unref)
VideoTable* video_table_get_instance (void);
GeeArrayList* video_table_get_all (VideoTable* self);
static void video_set_is_interpretable (Video* self,
                                 gboolean is_interpretable);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self,
                                                GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self,
                                                  GeeCollection* sources);
GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
gboolean video_has_interpreter_state_changed (void);
void video_notify_normal_thumbs_regenerated (void);
static void video_save_interpreter_state (void);
void video_notify_offline_thumbs_regenerated (void);
void configuration_facade_set_video_interpreter_state_cookie (ConfigurationFacade* self,
                                                              gint state_cookie);
void video_terminate (void);
GType exporter_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Exporter, g_object_unref)
gpointer exporter_ui_ref (gpointer instance);
void exporter_ui_unref (gpointer instance);
GParamSpec* param_spec_exporter_ui (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
void value_set_exporter_ui (GValue* value,
                            gpointer v_object);
void value_take_exporter_ui (GValue* value,
                             gpointer v_object);
gpointer value_get_exporter_ui (const GValue* value);
GType exporter_ui_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExporterUI, exporter_ui_unref)
ExporterUI* video_export_many (GeeCollection* videos,
                               ExporterCompletionCallback done,
                               gpointer done_target,
                               gboolean export_in_place);
void scaling_for_original (Scaling* result);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
GType jpeg_quality_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
void export_format_parameters_unmodified (ExportFormatParameters* result);
Exporter* exporter_new_for_temp_file (GeeCollection* to_export,
                                      Scaling* scaling,
                                      ExportFormatParameters* export_params);
Exporter* exporter_construct_for_temp_file (GType object_type,
                                            GeeCollection* to_export,
                                            Scaling* scaling,
                                            ExportFormatParameters* export_params);
ExporterUI* exporter_ui_new (Exporter* exporter);
ExporterUI* exporter_ui_construct (GType object_type,
                                   Exporter* exporter);
void exporter_ui_export (ExporterUI* self,
                         ExporterCompletionCallback completion_callback,
                         gpointer completion_callback_target);
GFile* export_ui_choose_file (const gchar* current_file_basename);
gchar* media_source_get_basename (MediaSource* self);
GType page_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageWindow, g_object_unref)
GType app_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppWindow, g_object_unref)
AppWindow* app_window_get_instance (void);
void page_window_set_busy_cursor (PageWindow* self);
void video_export (Video* self,
                   GFile* dest_file,
                   GError** error);
void page_window_set_normal_cursor (PageWindow* self);
GtkResponseType export_error_dialog (GFile* dest,
                                     gboolean photos_remaining);
GFile* export_ui_choose_dir (const gchar* user_title);
Exporter* exporter_new (GeeCollection* to_export,
                        GFile* dir,
                        Scaling* scaling,
                        ExportFormatParameters* export_params,
                        gboolean auto_replace_all);
Exporter* exporter_construct (GType object_type,
                              GeeCollection* to_export,
                              GFile* dir,
                              Scaling* scaling,
                              ExportFormatParameters* export_params,
                              gboolean auto_replace_all);
static void video_real_commit_backlinks (DataSource* base,
                                  SourceCollection* sources,
                                  const gchar* backlinks);
GQuark database_error_quark (void);
void video_table_update_backlinks (VideoTable* self,
                                   VideoID* video_id,
                                   const gchar* backlinks,
                                   GError** error);
void video_get_video_id (Video* self,
                         VideoID* result);
gchar* data_object_to_string (DataObject* self);
static gboolean video_real_set_event_id (MediaSource* base,
                                  EventID* event_id);
gboolean video_table_set_event (VideoTable* self,
                                VideoID* video_id,
                                EventID* event_id);
gboolean video_is_duplicate (GFile* file,
                             const gchar* full_md5);
gboolean video_table_has_duplicate (VideoTable* self,
                                    GFile* file,
                                    const gchar* md5);
ImportResult video_import_create (VideoImportParams* params,
                                  Video* * video);
void video_table_add (VideoTable* self,
                      VideoRow* video_row,
                      VideoID* result,
                      GError** error);
gboolean video_id_is_invalid (VideoID *self);
void video_import_failed (Video* video);
void video_table_remove (VideoTable* self,
                         VideoID* videoID,
                         GError** error);
void app_window_database_error (GError* err);
static BackingFileState** video_real_get_backing_files_state (MediaSource* base,
                                                       gint* result_length1);
BackingFileState* backing_file_state_new (const gchar* filepath,
                                          gint64 filesize,
                                          time_t modification_time,
                                          const gchar* md5);
BackingFileState* backing_file_state_construct (GType object_type,
                                                const gchar* filepath,
                                                gint64 filesize,
                                                time_t modification_time,
                                                const gchar* md5);
static GdkPixbuf* video_real_get_thumbnail (ThumbnailSource* base,
                                     gint scale,
                                     GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source,
                                  gint scale,
                                  GError** error);
static gchar* video_real_get_master_md5 (MediaSource* base);
static GdkPixbuf* video_real_get_preview_pixbuf (MediaSource* base,
                                          Scaling* scaling,
                                          GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self,
                                           gint scale,
                                           GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self,
                                      GdkPixbuf* pixbuf,
                                      GdkInterpType interp,
                                      gboolean scale_up);
static GdkPixbuf* video_real_create_thumbnail (ThumbnailSource* base,
                                        gint scale,
                                        GError** error);
GFile* media_source_get_file (MediaSource* self);
static gchar* video_real_get_typename (DataSource* base);
static gint64 video_real_get_instance_id (DataSource* base);
static void video_real_get_import_id (MediaSource* base,
                               ImportID* result);
static PhotoFileFormat video_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_file_format_get_system_default_format (void);
static gchar* video_real_get_title (MediaSource* base);
static void video_real_set_title (MediaSource* base,
                           const gchar* title);
void video_table_set_title (VideoTable* self,
                            VideoID* video_id,
                            const gchar* new_title,
                            GError** error);
void data_object_notify_altered (DataObject* self,
                                 Alteration* alteration);
Alteration* alteration_new (const gchar* subject,
                            const gchar* detail);
Alteration* alteration_construct (GType object_type,
                                  const gchar* subject,
                                  const gchar* detail);
static gchar* video_real_get_comment (MediaSource* base);
static gboolean video_real_set_comment (MediaSource* base,
                                 const gchar* comment);
void video_table_set_comment (VideoTable* self,
                              VideoID* video_id,
                              const gchar* new_comment,
                              GError** error);
static Rating video_real_get_rating (MediaSource* base);
static void video_real_set_rating (MediaSource* base,
                            Rating rating);
gboolean rating_is_valid (Rating self);
void video_table_set_rating (VideoTable* self,
                             VideoID* video_id,
                             Rating rating,
                             GError** error);
static void video_real_increase_rating (MediaSource* base);
void media_source_set_rating (MediaSource* self,
                              Rating rating);
Rating rating_increase (Rating self);
static void video_real_decrease_rating (MediaSource* base);
Rating rating_decrease (Rating self);
static gboolean video_real_is_trashed (MediaSource* base);
gboolean video_is_flag_set (Video* self,
                            guint64 flag);
static gboolean video_real_is_offline (Monitorable* base);
static void video_real_mark_offline (Monitorable* base);
guint64 video_add_flags (Video* self,
                         guint64 flags_to_add,
                         Alteration* additional_alteration);
static void video_real_mark_online (Monitorable* base);
guint64 video_remove_flags (Video* self,
                            guint64 flags_to_remove,
                            Alteration* additional_alteration);
gboolean video_get_is_interpretable (Video* self);
gpointer video_interpretable_results_ref (gpointer instance);
void video_interpretable_results_unref (gpointer instance);
GParamSpec* video_param_spec_interpretable_results (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags);
void video_value_set_interpretable_results (GValue* value,
                                            gpointer v_object);
void video_value_take_interpretable_results (GValue* value,
                                             gpointer v_object);
gpointer video_value_get_interpretable_results (const GValue* value);
GType video_interpretable_results_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoInterpretableResults, video_interpretable_results_unref)
VideoInterpretableResults* video_check_is_interpretable (Video* self);
void video_interpretable_results_foreground_finish (VideoInterpretableResults* self);
static void video_real_trash (MediaSource* base);
static void video_real_untrash (MediaSource* base);
static gboolean video_real_is_flagged (Flaggable* base);
static void video_real_mark_flagged (Flaggable* base);
static void video_real_mark_unflagged (Flaggable* base);
static void video_real_get_event_id (MediaSource* base,
                              EventID* result);
static gchar* video_real_to_string (DataObject* base);
static time_t video_real_get_exposure_time (Dateable* base);
static void video_real_set_exposure_time (Dateable* base,
                                   time_t time);
void video_table_set_exposure_time (VideoTable* self,
                                    VideoID* video_id,
                                    time_t time,
                                    GError** error);
void video_get_frame_dimensions (Video* self,
                                 Dimensions* result);
void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
static void video_real_get_dimensions (MediaSource* base,
                                PhotoException disallowed_steps,
                                Dimensions* result);
static guint64 video_real_get_filesize (MediaSource* base);
guint64 media_source_get_master_filesize (MediaSource* self);
static guint64 video_real_get_master_filesize (MediaSource* base);
static time_t video_real_get_timestamp (MediaSource* base);
static void video_real_set_master_timestamp (Monitorable* base,
                                      GFileInfo* info);
void video_table_set_timestamp (VideoTable* self,
                                VideoID* video_id,
                                time_t timestamp,
                                GError** error);
gchar* video_get_filename (Video* self);
static GFile* video_real_get_file (MediaSource* base);
static GFile* video_real_get_master_file (MediaSource* base);
gdouble video_get_clip_duration (Video* self);
void video_table_update_is_interpretable (VideoTable* self,
                                          VideoID* video_id,
                                          gboolean is_interpretable,
                                          GError** error);
VideoInterpretableResults* video_interpretable_results_new (Video* video);
VideoInterpretableResults* video_interpretable_results_construct (GType object_type,
                                                                  Video* video);
static void video_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
static gboolean video_real_internal_delete_backing (DataSource* base,
                                             GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
gboolean data_source_internal_delete_backing (DataSource* self,
                                              GError** error);
static void video_notify_flags_altered (Video* self,
                                 Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self,
                                 Alteration* other);
guint64 media_source_internal_add_flags (guint64 flags,
                                         guint64 selector);
void video_table_set_flags (VideoTable* self,
                            VideoID* video_id,
                            guint64 flags,
                            GError** error);
guint64 media_source_internal_remove_flags (guint64 flags,
                                            guint64 selector);
gboolean media_source_internal_is_flag_set (guint64 flags,
                                            guint64 selector);
static void video_real_set_master_file (Monitorable* base,
                                 GFile* file);
void video_table_set_filepath (VideoTable* self,
                               VideoID* video_id,
                               const gchar* filepath,
                               GError** error);
void media_source_notify_master_replaced (MediaSource* self,
                                          GFile* old_file,
                                          GFile* new_file);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type,
                                            const gchar* list);
VideoMetadata* video_read_metadata (Video* self,
                                    GError** error);
void thumbnail_cache_replace (ThumbnailSource* source,
                              ThumbnailCacheSize size,
                              GdkPixbuf* replacement,
                              GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void video_interpretable_results_finalize (VideoInterpretableResults * obj);
static void video_finalize (GObject * obj);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
void value_set_source_backlink (GValue* value,
                                gpointer v_object);
void value_take_source_backlink (GValue* value,
                                 gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceBacklink, source_backlink_unref)
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceHoldingTank, source_holding_tank_unref)
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceHoldingTank, source_holding_tank_unref)
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
void value_set_workers (GValue* value,
                        gpointer v_object);
void value_take_workers (GValue* value,
                         gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Workers, workers_unref)
GType media_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaMonitor, g_object_unref)
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
void value_set_transaction_controller (GValue* value,
                                       gpointer v_object);
void value_take_transaction_controller (GValue* value,
                                        gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TransactionController, transaction_controller_unref)
GType video_source_collection_state_get_type (void) G_GNUC_CONST;
gint uint64_compare (guint64* a,
                     guint64* b);
static gint _uint64_compare_gcompare_data_func (gconstpointer a,
                                         gconstpointer b,
                                         gpointer self);
static guint64* _uint64_dup (guint64* self);
gint64 video_source_collection_get_video_key (DataSource* source);
static gint64 _video_source_collection_get_video_key_get_source_database_key (DataSource* source,
                                                                       gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type,
                                                          const gchar* name,
                                                          GetSourceDatabaseKey source_key_func,
                                                          gpointer source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void video_source_collection_on_trashcan_contents_altered (VideoSourceCollection* self,
                                                           GeeCollection* added,
                                                           GeeCollection* removed);
static void _video_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                 GeeCollection* added,
                                                                                                 GeeCollection* removed,
                                                                                                 gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void video_source_collection_on_offline_contents_altered (VideoSourceCollection* self,
                                                          GeeCollection* added,
                                                          GeeCollection* removed);
static void _video_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                                GeeCollection* added,
                                                                                                GeeCollection* removed,
                                                                                                gpointer self);
static MediaSourceHoldingTank* video_source_collection_real_create_trashcan (MediaSourceCollection* base);
gboolean video_source_collection_is_video_trashed (DataSource* source);
static gboolean _video_source_collection_is_video_trashed_source_holding_tank_check_to_keep (DataSource* source,
                                                                                      Alteration* alteration,
                                                                                      gpointer self);
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources,
                                                       SourceHoldingTankCheckToKeep check_to_keep,
                                                       gpointer check_to_keep_target,
                                                       GetSourceDatabaseKey get_key,
                                                       gpointer get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type,
                                                             MediaSourceCollection* sources,
                                                             SourceHoldingTankCheckToKeep check_to_keep,
                                                             gpointer check_to_keep_target,
                                                             GetSourceDatabaseKey get_key,
                                                             gpointer get_key_target);
static MediaSourceHoldingTank* video_source_collection_real_create_offline_bin (MediaSourceCollection* base);
gboolean video_source_collection_is_video_offline (DataSource* source);
static gboolean _video_source_collection_is_video_offline_source_holding_tank_check_to_keep (DataSource* source,
                                                                                      Alteration* alteration,
                                                                                      gpointer self);
static MediaMonitor* video_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                                 Workers* workers,
                                                                 GCancellable* cancellable);
VideoMonitor* video_monitor_new (GCancellable* cancellable);
VideoMonitor* video_monitor_construct (GType object_type,
                                       GCancellable* cancellable);
GType video_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoMonitor, g_object_unref)
static gboolean video_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                            DataSource* source);
static gchar* video_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean video_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                          GFile* file);
static MediaSource* video_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                               gint64 numeric_id);
Video* video_source_collection_fetch (VideoSourceCollection* self,
                                      VideoID* video_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self,
                                                     gint64 key);
static GeeCollection* video_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                                  EventID* event_id);
GeeArrayList* video_table_get_event_source_ids (VideoTable* self,
                                                EventID* event_id);
Video* video_source_collection_get_state_by_file (VideoSourceCollection* self,
                                                  GFile* file,
                                                  VideoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self,
                                                           GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
static void video_source_collection_compare_backing (VideoSourceCollection* self,
                                              Video* video,
                                              GFileInfo* info,
                                              GeeCollection* matching_master);
guint64 media_source_get_filesize (MediaSource* self);
time_t media_source_get_timestamp (MediaSource* self);
void video_source_collection_fetch_by_matching_backing (VideoSourceCollection* self,
                                                        GFileInfo* info,
                                                        GeeCollection* matching_master);
GeeCollection* data_collection_get_all (DataCollection* self);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
static void video_source_collection_real_notify_contents_altered (DataCollection* base,
                                                           GeeIterable* added,
                                                           GeeIterable* removed);
void data_collection_notify_contents_altered (DataCollection* self,
                                              GeeIterable* added,
                                              GeeIterable* removed);
void video_source_collection_get_basename_filesize_duplicate (VideoSourceCollection* self,
                                                              const gchar* basename,
                                                              guint64 filesize,
                                                              VideoID* result);
GFile* media_source_get_master_file (MediaSource* self);
gboolean video_source_collection_has_basename_filesize_duplicate (VideoSourceCollection* self,
                                                                  const gchar* basename,
                                                                  guint64 filesize);
gboolean video_id_is_valid (VideoID *self);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type,
                                                                                 MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceTransactionController, transaction_controller_unref)
static void video_source_collection_finalize (DataCollection * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const gchar* VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS[4] = {"bdm", "bdmv", "cpi", "mpl"};

GQuark
video_error_quark (void)
{
	return g_quark_from_static_string ("video-error-quark");
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gpointer
_thumbnails_ref0 (gpointer self)
{
	return self ? thumbnails_ref (self) : NULL;
}

VideoImportParams*
video_import_params_construct (GType object_type,
                               GFile* file,
                               ImportID* import_id,
                               const gchar* md5,
                               Thumbnails* thumbnails,
                               time_t exposure_time_override)
{
	VideoImportParams* self = NULL;
	GFile* _tmp0_;
	ImportID _tmp1_;
	gchar* _tmp2_;
	Thumbnails* _tmp3_;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
	g_return_val_if_fail (import_id != NULL, NULL);
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
	self = (VideoImportParams*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->file);
	self->file = _tmp0_;
	_tmp1_ = *import_id;
	self->import_id = _tmp1_;
	_tmp2_ = g_strdup (md5);
	_g_free0 (self->md5);
	self->md5 = _tmp2_;
	_tmp3_ = _thumbnails_ref0 (thumbnails);
	_thumbnails_unref0 (self->thumbnails);
	self->thumbnails = _tmp3_;
	self->exposure_time_override = exposure_time_override;
	return self;
}

VideoImportParams*
video_import_params_new (GFile* file,
                         ImportID* import_id,
                         const gchar* md5,
                         Thumbnails* thumbnails,
                         time_t exposure_time_override)
{
	return video_import_params_construct (TYPE_VIDEO_IMPORT_PARAMS, file, import_id, md5, thumbnails, exposure_time_override);
}

static void
value_video_import_params_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_video_import_params_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		video_import_params_unref (value->data[0].v_pointer);
	}
}

static void
value_video_import_params_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = video_import_params_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_video_import_params_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_video_import_params_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		VideoImportParams * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = video_import_params_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_video_import_params_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	VideoImportParams ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = video_import_params_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_video_import_params (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecVideoImportParams* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_IMPORT_PARAMS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_video_import_params (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_IMPORT_PARAMS), NULL);
	return value->data[0].v_pointer;
}

void
value_set_video_import_params (GValue* value,
                               gpointer v_object)
{
	VideoImportParams * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_IMPORT_PARAMS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_IMPORT_PARAMS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		video_import_params_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		video_import_params_unref (old);
	}
}

void
value_take_video_import_params (GValue* value,
                                gpointer v_object)
{
	VideoImportParams * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_IMPORT_PARAMS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_IMPORT_PARAMS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		video_import_params_unref (old);
	}
}

static void
video_import_params_class_init (VideoImportParamsClass * klass,
                                gpointer klass_data)
{
	video_import_params_parent_class = g_type_class_peek_parent (klass);
	((VideoImportParamsClass *) klass)->finalize = video_import_params_finalize;
}

static void
video_import_params_instance_init (VideoImportParams * self,
                                   gpointer klass)
{
	VideoRow* _tmp0_;
	import_id_init (&self->import_id, IMPORT_ID_INVALID);
	_tmp0_ = video_row_new ();
	self->row = _tmp0_;
	self->ref_count = 1;
}

static void
video_import_params_finalize (VideoImportParams * obj)
{
	VideoImportParams * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->file);
	_g_free0 (self->md5);
	_thumbnails_unref0 (self->thumbnails);
	_video_row_unref0 (self->row);
}

GType
video_import_params_get_type (void)
{
	static volatile gsize video_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&video_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_video_import_params_init, value_video_import_params_free_value, value_video_import_params_copy_value, value_video_import_params_peek_pointer, "p", value_video_import_params_collect_value, "p", value_video_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoImportParams), 0, (GInstanceInitFunc) video_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_import_params_type_id;
		video_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&video_import_params_type_id__volatile, video_import_params_type_id);
	}
	return video_import_params_type_id__volatile;
}

gpointer
video_import_params_ref (gpointer instance)
{
	VideoImportParams * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
video_import_params_unref (gpointer instance)
{
	VideoImportParams * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIDEO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
video_reader_get_instance_private (VideoReader* self)
{
	return G_STRUCT_MEMBER_P (self, VideoReader_private_offset);
}

VideoReader*
video_reader_construct (GType object_type,
                        GFile* file)
{
	VideoReader* self = NULL;
	GFile* _tmp0_;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
	self = (VideoReader*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (file);
	_g_object_unref0 (self->priv->file);
	self->priv->file = _tmp0_;
	return self;
}

VideoReader*
video_reader_new (GFile* file)
{
	return video_reader_construct (TYPE_VIDEO_READER, file);
}

gboolean
video_reader_is_supported_video_file (GFile* file)
{
	gchar* mime_type = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guchar* _tmp2_;
	guchar* _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
	_tmp0_ = g_file_get_basename (file);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_new0 (guchar, 0);
	_tmp3_ = _tmp2_;
	_tmp3__length1 = 0;
	_tmp4_ = g_content_type_guess (_tmp1_, _tmp3_, (gsize) 0, NULL);
	_tmp5_ = _tmp4_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	_g_free0 (_tmp1_);
	mime_type = _tmp5_;
	_tmp7_ = mime_type;
	if (g_strcmp0 (_tmp7_, "audio/ogg") == 0) {
		_tmp6_ = g_file_has_uri_scheme (file, "file");
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		{
			GFileInfo* info = NULL;
			GFileInfo* _tmp8_;
			gchar* content_type = NULL;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			const gchar* _tmp13_;
			_tmp8_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
			info = _tmp8_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch501_g_error;
			}
			_tmp9_ = info;
			_tmp10_ = g_file_info_get_content_type (_tmp9_);
			_tmp11_ = g_strdup (_tmp10_);
			content_type = _tmp11_;
			_tmp13_ = content_type;
			if (_tmp13_ != NULL) {
				const gchar* _tmp14_;
				_tmp14_ = content_type;
				_tmp12_ = g_str_has_prefix (_tmp14_, "video/");
			} else {
				_tmp12_ = FALSE;
			}
			if (_tmp12_) {
				result = TRUE;
				_g_free0 (content_type);
				_g_object_unref0 (info);
				_g_free0 (mime_type);
				return result;
			}
			_g_free0 (content_type);
			_g_object_unref0 (info);
		}
		goto __finally501;
		__catch501_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
			_error_ = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp15_ = _error_;
			_tmp16_ = _tmp15_->message;
			g_debug ("VideoSupport.vala:67: Failed to query content type: %s", _tmp16_);
			_g_error_free0 (_error_);
		}
		__finally501:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp17_ = FALSE;
			_g_free0 (mime_type);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp17_;
		}
	}
	_tmp18_ = g_file_get_basename (file);
	_tmp19_ = _tmp18_;
	_tmp20_ = video_reader_is_supported_video_filename (_tmp19_);
	_g_free0 (_tmp19_);
	result = _tmp20_;
	_g_free0 (mime_type);
	return result;
}

gboolean
video_reader_is_supported_video_filename (const gchar* filename)
{
	gchar* mime_type = NULL;
	guchar* _tmp0_;
	guchar* _tmp1_;
	gint _tmp1__length1;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean result = FALSE;
	g_return_val_if_fail (filename != NULL, FALSE);
	_tmp0_ = g_new0 (guchar, 0);
	_tmp1_ = _tmp0_;
	_tmp1__length1 = 0;
	_tmp2_ = g_content_type_guess (filename, _tmp1_, (gsize) 0, NULL);
	_g_free0 (mime_type);
	mime_type = _tmp2_;
	_tmp1_ = (g_free (_tmp1_), NULL);
	_tmp4_ = mime_type;
	if (g_str_has_prefix (_tmp4_, "video/")) {
		_tmp3_ = TRUE;
	} else {
		const gchar* _tmp5_;
		_tmp5_ = mime_type;
		_tmp3_ = g_str_has_suffix (_tmp5_, "mp4");
	}
	if (_tmp3_) {
		gchar* extension = NULL;
		gchar* name = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		const gchar* _tmp8_;
		extension = NULL;
		name = NULL;
		disassemble_filename (filename, &_tmp6_, &_tmp7_);
		_g_free0 (name);
		name = _tmp6_;
		_g_free0 (extension);
		extension = _tmp7_;
		_tmp8_ = extension;
		if (_tmp8_ == NULL) {
			result = TRUE;
			_g_free0 (name);
			_g_free0 (extension);
			_g_free0 (mime_type);
			return result;
		}
		{
			const gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
			s_collection = VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS;
			s_collection_length1 = G_N_ELEMENTS (VIDEO_READER_METADATA_ONLY_FILE_EXTENSIONS);
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
				gchar* _tmp9_;
				gchar* s = NULL;
				_tmp9_ = g_strdup (s_collection[s_it]);
				s = _tmp9_;
				{
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					_tmp10_ = s;
					_tmp11_ = extension;
					if (utf8_ci_compare (_tmp10_, _tmp11_) == 0) {
						result = FALSE;
						_g_free0 (s);
						_g_free0 (name);
						_g_free0 (extension);
						_g_free0 (mime_type);
						return result;
					}
					_g_free0 (s);
				}
			}
		}
		result = TRUE;
		_g_free0 (name);
		_g_free0 (extension);
		_g_free0 (mime_type);
		return result;
	} else {
		const gchar* _tmp12_;
		_tmp12_ = mime_type;
		g_debug ("VideoSupport.vala:93: Skipping %s, unsupported mime type %s", filename, _tmp12_);
		result = FALSE;
		_g_free0 (mime_type);
		return result;
	}
	_g_free0 (mime_type);
}

ImportResult
video_reader_prepare_for_import (VideoImportParams* params)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	GFile* _tmp7_;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp11_;
	GTimeVal _tmp12_ = {0};
	const gchar* _tmp13_;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp14_;
	gchar* comment = NULL;
	gchar* _tmp15_;
	VideoReader* reader = NULL;
	GFile* _tmp16_;
	VideoReader* _tmp17_;
	gboolean is_interpretable = FALSE;
	gdouble clip_duration = 0.0;
	GdkPixbuf* preview_frame = NULL;
	VideoReader* _tmp18_;
	GdkPixbuf* _tmp19_;
	VideoRow* _tmp49_;
	VideoRow* _tmp50_;
	GFile* _tmp51_;
	gchar* _tmp52_;
	VideoRow* _tmp53_;
	GFileInfo* _tmp54_;
	VideoRow* _tmp55_;
	GTimeVal _tmp56_;
	VideoRow* _tmp57_;
	GdkPixbuf* _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	VideoRow* _tmp61_;
	GdkPixbuf* _tmp62_;
	gint _tmp63_;
	gint _tmp64_;
	VideoRow* _tmp65_;
	VideoRow* _tmp66_;
	VideoRow* _tmp67_;
	VideoRow* _tmp68_;
	ImportID _tmp69_;
	VideoRow* _tmp70_;
	VideoRow* _tmp71_;
	const gchar* _tmp72_;
	gchar* _tmp73_;
	VideoRow* _tmp74_;
	VideoRow* _tmp75_;
	const gchar* _tmp76_;
	gchar* _tmp77_;
	VideoRow* _tmp78_;
	const gchar* _tmp79_;
	gchar* _tmp80_;
	VideoRow* _tmp81_;
	gchar* _tmp82_;
	VideoRow* _tmp83_;
	VideoRow* _tmp84_;
	Thumbnails* _tmp85_;
	GError* _inner_error0_ = NULL;
	ImportResult result = 0;
	g_return_val_if_fail (IS_VIDEO_IMPORT_PARAMS (params), 0);
	_tmp0_ = params->file;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	file = _tmp1_;
	info = NULL;
	{
		GFileInfo* _tmp2_ = NULL;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
		_tmp3_ = file;
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
		_tmp2_ = _tmp4_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch502_g_error;
		}
		_tmp5_ = _tmp2_;
		_tmp2_ = NULL;
		_g_object_unref0 (info);
		info = _tmp5_;
		_g_object_unref0 (_tmp2_);
	}
	goto __finally502;
	__catch502_g_error:
	{
		GError* err = NULL;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		result = IMPORT_RESULT_FILE_ERROR;
		_g_error_free0 (err);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	__finally502:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return 0;
	}
	_tmp6_ = info;
	if (g_file_info_get_file_type (_tmp6_) != G_FILE_TYPE_REGULAR) {
		result = IMPORT_RESULT_NOT_A_FILE;
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	_tmp7_ = file;
	if (!video_reader_is_supported_video_file (_tmp7_)) {
		GFile* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp8_ = file;
		_tmp9_ = g_file_get_path (_tmp8_);
		_tmp10_ = _tmp9_;
		g_message ("Not importing %s: file is marked as a video file but doesn't have a" "supported extension", _tmp10_);
		_g_free0 (_tmp10_);
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		return result;
	}
	_tmp11_ = info;
	g_file_info_get_modification_time (_tmp11_, &_tmp12_);
	timestamp = _tmp12_;
	_tmp13_ = params->md5;
	_vala_assert (_tmp13_ != NULL, "params.md5 != null");
	exposure_time = params->exposure_time_override;
	_tmp14_ = g_strdup ("");
	title = _tmp14_;
	_tmp15_ = g_strdup ("");
	comment = _tmp15_;
	_tmp16_ = file;
	_tmp17_ = video_reader_new (_tmp16_);
	reader = _tmp17_;
	is_interpretable = TRUE;
	clip_duration = 0.0;
	_tmp18_ = reader;
	_tmp19_ = video_reader_read_preview_frame (_tmp18_);
	preview_frame = _tmp19_;
	{
		gdouble _tmp20_ = 0.0;
		VideoReader* _tmp21_;
		_tmp21_ = reader;
		_tmp20_ = video_reader_read_clip_duration (_tmp21_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VIDEO_ERROR) {
				goto __catch503_video_error;
			}
			_g_object_unref0 (preview_frame);
			_video_reader_unref0 (reader);
			_g_free0 (comment);
			_g_free0 (title);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return 0;
		}
		clip_duration = _tmp20_;
	}
	goto __finally503;
	__catch503_video_error:
	{
		GError* err = NULL;
		GError* _tmp22_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp22_ = err;
		if (g_error_matches (_tmp22_, VIDEO_ERROR, VIDEO_ERROR_FILE)) {
			result = IMPORT_RESULT_FILE_ERROR;
			_g_error_free0 (err);
			_g_object_unref0 (preview_frame);
			_video_reader_unref0 (reader);
			_g_free0 (comment);
			_g_free0 (title);
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			return result;
		} else {
			GError* _tmp23_;
			_tmp23_ = err;
			if (g_error_matches (_tmp23_, VIDEO_ERROR, VIDEO_ERROR_CONTENTS)) {
				is_interpretable = FALSE;
				clip_duration = 0.0;
			} else {
				g_error ("VideoSupport.vala:144: can't prepare video for import: an unknown kind" \
" of video error occurred");
			}
		}
		_g_error_free0 (err);
	}
	__finally503:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (preview_frame);
		_video_reader_unref0 (reader);
		_g_free0 (comment);
		_g_free0 (title);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return 0;
	}
	{
		VideoMetadata* metadata = NULL;
		VideoReader* _tmp24_;
		VideoMetadata* _tmp25_;
		MetadataDateTime* creation_date_time = NULL;
		VideoMetadata* _tmp26_;
		MetadataDateTime* _tmp27_;
		gboolean _tmp28_ = FALSE;
		MetadataDateTime* _tmp29_;
		gchar* video_title = NULL;
		VideoMetadata* _tmp32_;
		gchar* _tmp33_;
		gchar* video_comment = NULL;
		VideoMetadata* _tmp34_;
		gchar* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp39_;
		_tmp24_ = reader;
		_tmp25_ = video_reader_read_metadata (_tmp24_, &_inner_error0_);
		metadata = _tmp25_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch504_g_error;
		}
		_tmp26_ = metadata;
		_tmp27_ = media_metadata_get_creation_date_time (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_MEDIA_METADATA, MediaMetadata));
		creation_date_time = _tmp27_;
		_tmp29_ = creation_date_time;
		if (_tmp29_ != NULL) {
			MetadataDateTime* _tmp30_;
			_tmp30_ = creation_date_time;
			_tmp28_ = metadata_date_time_get_timestamp (_tmp30_) != ((time_t) 0);
		} else {
			_tmp28_ = FALSE;
		}
		if (_tmp28_) {
			MetadataDateTime* _tmp31_;
			_tmp31_ = creation_date_time;
			exposure_time = metadata_date_time_get_timestamp (_tmp31_);
		}
		_tmp32_ = metadata;
		_tmp33_ = media_metadata_get_title (G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_MEDIA_METADATA, MediaMetadata));
		video_title = _tmp33_;
		_tmp34_ = metadata;
		_tmp35_ = media_metadata_get_comment (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_MEDIA_METADATA, MediaMetadata));
		video_comment = _tmp35_;
		_tmp36_ = video_title;
		if (_tmp36_ != NULL) {
			const gchar* _tmp37_;
			gchar* _tmp38_;
			_tmp37_ = video_title;
			_tmp38_ = g_strdup (_tmp37_);
			_g_free0 (title);
			title = _tmp38_;
		}
		_tmp39_ = video_comment;
		if (_tmp39_ != NULL) {
			const gchar* _tmp40_;
			gchar* _tmp41_;
			_tmp40_ = video_comment;
			_tmp41_ = g_strdup (_tmp40_);
			_g_free0 (comment);
			comment = _tmp41_;
		}
		_g_free0 (video_comment);
		_g_free0 (video_title);
		_metadata_date_time_unref0 (creation_date_time);
		_media_metadata_unref0 (metadata);
	}
	goto __finally504;
	__catch504_g_error:
	{
		GError* err = NULL;
		GError* _tmp42_;
		const gchar* _tmp43_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp42_ = err;
		_tmp43_ = _tmp42_->message;
		g_warning ("VideoSupport.vala:162: Unable to read video metadata: %s", _tmp43_);
		_g_error_free0 (err);
	}
	__finally504:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (preview_frame);
		_video_reader_unref0 (reader);
		_g_free0 (comment);
		_g_free0 (title);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return 0;
	}
	if (exposure_time == ((time_t) 0)) {
		gint64 _tmp44_ = 0LL;
		VideoReader* _tmp45_;
		GDateTime* _tmp46_;
		_tmp45_ = reader;
		_tmp46_ = _tmp45_->priv->_timestamp;
		if (_tmp46_ != NULL) {
			VideoReader* _tmp47_;
			GDateTime* _tmp48_;
			_tmp47_ = reader;
			_tmp48_ = _tmp47_->priv->_timestamp;
			_tmp44_ = g_date_time_to_unix (_tmp48_);
		} else {
			_tmp44_ = (gint64) 0;
		}
		exposure_time = (time_t) _tmp44_;
	}
	_tmp49_ = params->row;
	video_id_init (&_tmp49_->video_id, VIDEO_ID_INVALID);
	_tmp50_ = params->row;
	_tmp51_ = file;
	_tmp52_ = g_file_get_path (_tmp51_);
	_g_free0 (_tmp50_->filepath);
	_tmp50_->filepath = _tmp52_;
	_tmp53_ = params->row;
	_tmp54_ = info;
	_tmp53_->filesize = g_file_info_get_size (_tmp54_);
	_tmp55_ = params->row;
	_tmp56_ = timestamp;
	_tmp55_->timestamp = (time_t) _tmp56_.tv_sec;
	_tmp57_ = params->row;
	_tmp58_ = preview_frame;
	_tmp59_ = gdk_pixbuf_get_width (_tmp58_);
	_tmp60_ = _tmp59_;
	_tmp57_->width = _tmp60_;
	_tmp61_ = params->row;
	_tmp62_ = preview_frame;
	_tmp63_ = gdk_pixbuf_get_height (_tmp62_);
	_tmp64_ = _tmp63_;
	_tmp61_->height = _tmp64_;
	_tmp65_ = params->row;
	_tmp65_->clip_duration = clip_duration;
	_tmp66_ = params->row;
	_tmp66_->is_interpretable = is_interpretable;
	_tmp67_ = params->row;
	_tmp67_->exposure_time = exposure_time;
	_tmp68_ = params->row;
	_tmp69_ = params->import_id;
	_tmp68_->import_id = _tmp69_;
	_tmp70_ = params->row;
	event_id_init (&_tmp70_->event_id, EVENT_ID_INVALID);
	_tmp71_ = params->row;
	_tmp72_ = params->md5;
	_tmp73_ = g_strdup (_tmp72_);
	_g_free0 (_tmp71_->md5);
	_tmp71_->md5 = _tmp73_;
	_tmp74_ = params->row;
	_tmp74_->time_created = (time_t) 0;
	_tmp75_ = params->row;
	_tmp76_ = title;
	_tmp77_ = g_strdup (_tmp76_);
	_g_free0 (_tmp75_->title);
	_tmp75_->title = _tmp77_;
	_tmp78_ = params->row;
	_tmp79_ = comment;
	_tmp80_ = g_strdup (_tmp79_);
	_g_free0 (_tmp78_->comment);
	_tmp78_->comment = _tmp80_;
	_tmp81_ = params->row;
	_tmp82_ = g_strdup ("");
	_g_free0 (_tmp81_->backlinks);
	_tmp81_->backlinks = _tmp82_;
	_tmp83_ = params->row;
	_tmp83_->time_reimported = (time_t) 0;
	_tmp84_ = params->row;
	_tmp84_->flags = (guint64) 0;
	_tmp85_ = params->thumbnails;
	if (_tmp85_ != NULL) {
		Thumbnails* _tmp86_;
		Thumbnails* _tmp87_;
		GdkPixbuf* _tmp88_;
		_tmp86_ = thumbnails_new ();
		_thumbnails_unref0 (params->thumbnails);
		params->thumbnails = _tmp86_;
		_tmp87_ = params->thumbnails;
		_tmp88_ = preview_frame;
		thumbnail_cache_generate_for_video_frame (_tmp87_, _tmp88_);
	}
	result = IMPORT_RESULT_SUCCESS;
	_g_object_unref0 (preview_frame);
	_video_reader_unref0 (reader);
	_g_free0 (comment);
	_g_free0 (title);
	_g_object_unref0 (info);
	_g_object_unref0 (file);
	return result;
}

static GDate*
_g_date_dup (GDate* self)
{
	GDate* dup;
	dup = g_new0 (GDate, 1);
	memcpy (dup, self, sizeof (GDate));
	return dup;
}

static gpointer
__g_date_dup0 (gpointer self)
{
	return self ? _g_date_dup (self) : NULL;
}

static void
video_reader_read_internal (VideoReader* self,
                            GError** error)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (IS_VIDEO_READER (self));
	if (!video_reader_does_file_exist (self)) {
		GFile* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
		_tmp0_ = self->priv->file;
		_tmp1_ = g_file_get_path (_tmp0_);
		_tmp2_ = _tmp1_;
		_tmp3_ = g_strdup_printf ("video file '%s' does not exist or is inaccessible", _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_FILE, _tmp4_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		_g_free0 (_tmp2_);
		_inner_error0_ = _tmp6_;
		if (_inner_error0_->domain == VIDEO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	{
		GstDiscoverer* d = NULL;
		GstDiscoverer* _tmp7_;
		GstDiscovererInfo* info = NULL;
		GstDiscoverer* _tmp8_;
		GFile* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GstDiscovererInfo* _tmp12_;
		GstDiscovererInfo* _tmp13_;
		GstDiscovererInfo* _tmp14_;
		GDate* video_date = NULL;
		gboolean _tmp15_ = FALSE;
		GstDiscovererInfo* _tmp16_;
		GstTagList* _tmp17_;
		_tmp7_ = gst_discoverer_new ((GstClockTime) (GST_SECOND * 5), &_inner_error0_);
		d = _tmp7_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch505_g_error;
		}
		_tmp8_ = d;
		_tmp9_ = self->priv->file;
		_tmp10_ = g_file_get_uri (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = gst_discoverer_discover_uri (_tmp8_, _tmp11_, &_inner_error0_);
		_tmp13_ = _tmp12_;
		_g_free0 (_tmp11_);
		info = _tmp13_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (d);
			goto __catch505_g_error;
		}
		_tmp14_ = info;
		self->priv->clip_duration = ((gdouble) gst_discoverer_info_get_duration (_tmp14_)) / 1000000000.0;
		video_date = NULL;
		_tmp16_ = info;
		_tmp17_ = gst_discoverer_info_get_tags (_tmp16_);
		if (_tmp17_ != NULL) {
			GstDiscovererInfo* _tmp18_;
			GstTagList* _tmp19_;
			GDate _tmp20_ = {0};
			gboolean _tmp21_;
			GDate _tmp22_;
			GDate* _tmp23_;
			_tmp18_ = info;
			_tmp19_ = gst_discoverer_info_get_tags (_tmp18_);
			_tmp21_ = gst_tag_list_get_date (_tmp19_, GST_TAG_DATE, &_tmp20_);
			_g_free0 (video_date);
			_tmp22_ = _tmp20_;
			_tmp23_ = __g_date_dup0 (&_tmp22_);
			video_date = _tmp23_;
			_tmp15_ = _tmp21_;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			GDate* _tmp24_;
			_tmp24_ = video_date;
			if (_tmp24_ != NULL) {
				GDate* _tmp25_;
				GDate* _tmp26_;
				GDate* _tmp27_;
				GDateTime* _tmp28_;
				GDateTime* _tmp29_;
				_tmp25_ = video_date;
				_tmp26_ = video_date;
				_tmp27_ = video_date;
				_tmp28_ = g_date_time_new_local ((gint) g_date_get_year (_tmp25_), (gint) g_date_get_month (_tmp26_), (gint) g_date_get_day (_tmp27_), 0, 0, (gdouble) 0);
				_tmp29_ = _tmp28_;
				video_reader_set_timestamp (self, _tmp29_);
				_g_date_time_unref0 (_tmp29_);
			}
		}
		_g_free0 (video_date);
		_g_object_unref0 (info);
		_g_object_unref0 (d);
	}
	goto __finally505;
	__catch505_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
		GError* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GError* _tmp36_;
		GError* _tmp37_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp30_ = e;
		_tmp31_ = _tmp30_->message;
		g_debug ("VideoSupport.vala:224: Video read error: %s", _tmp31_);
		_tmp32_ = e;
		_tmp33_ = _tmp32_->message;
		_tmp34_ = g_strdup_printf ("GStreamer couldn't extract clip information: %s", _tmp33_);
		_tmp35_ = _tmp34_;
		_tmp36_ = g_error_new_literal (VIDEO_ERROR, VIDEO_ERROR_CONTENTS, _tmp35_);
		_tmp37_ = _tmp36_;
		_g_free0 (_tmp35_);
		_inner_error0_ = _tmp37_;
		_g_error_free0 (e);
		goto __finally505;
	}
	__finally505:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == VIDEO_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static gboolean
video_reader_on_thumbnailer_timer (VideoReader* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
	g_debug ("VideoSupport.vala:232: Thumbnailer timer called");
	if (self->priv->thumbnailer_pid != ((GPid) 0)) {
		g_debug ("VideoSupport.vala:234: Killing thumbnailer process: %d", (gint) self->priv->thumbnailer_pid);
		kill ((pid_t) self->priv->thumbnailer_pid, (gint) SIGKILL);
	}
	result = FALSE;
	return result;
}

static gboolean
_video_reader_on_thumbnailer_timer_gsource_func (gpointer self)
{
	gboolean result;
	result = video_reader_on_thumbnailer_timer ((VideoReader*) self);
	return result;
}

static GdkPixbuf*
video_reader_thumbnailer (VideoReader* self,
                          const gchar* video_file)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar** argv = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gint argv_length1;
	gint _argv_size_;
	gint child_stdout = 0;
	GdkPixbuf* buf = NULL;
	gint child_status = 0;
	gint ret_waitpid = 0;
	gint _tmp22_ = 0;
	pid_t _tmp23_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
	g_return_val_if_fail (video_file != NULL, NULL);
	_tmp0_ = app_dirs_get_thumbnailer_bin ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_get_path (_tmp1_);
	_tmp3_ = _tmp2_;
	g_debug ("VideoSupport.vala:248: Launching thumbnailer process: %s", _tmp3_);
	_g_free0 (_tmp3_);
	_g_object_unref0 (_tmp1_);
	_tmp4_ = app_dirs_get_thumbnailer_bin ();
	_tmp5_ = _tmp4_;
	_tmp6_ = g_file_get_path (_tmp5_);
	_tmp7_ = g_strdup (video_file);
	_tmp8_ = g_new0 (gchar*, 2 + 1);
	_tmp8_[0] = _tmp6_;
	_tmp8_[1] = _tmp7_;
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 2;
	_g_object_unref0 (_tmp5_);
	argv = _tmp9_;
	argv_length1 = _tmp9__length1;
	_argv_size_ = argv_length1;
	{
		gchar** _tmp10_;
		gint _tmp10__length1;
		GPid _tmp11_ = 0;
		gint _tmp12_ = 0;
		_tmp10_ = argv;
		_tmp10__length1 = argv_length1;
		g_spawn_async_with_pipes (NULL, _tmp10_, NULL, G_SPAWN_SEARCH_PATH | G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &_tmp11_, NULL, &_tmp12_, NULL, &_inner_error0_);
		self->priv->thumbnailer_pid = _tmp11_;
		child_stdout = _tmp12_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch506_g_error;
		}
		g_debug ("VideoSupport.vala:255: Spawned thumbnailer, child pid: %d", (gint) self->priv->thumbnailer_pid);
	}
	goto __finally506;
	__catch506_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		g_debug ("VideoSupport.vala:257: Error spawning process: %s", _tmp14_);
		if (self->priv->thumbnailer_pid != ((GPid) 0)) {
			g_spawn_close_pid (self->priv->thumbnailer_pid);
		}
		result = NULL;
		_g_error_free0 (e);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		return result;
	}
	__finally506:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	g_timeout_add_full (G_PRIORITY_DEFAULT, VIDEO_READER_THUMBNAILER_TIMEOUT, _video_reader_on_thumbnailer_timer_gsource_func, video_reader_ref (self), video_reader_unref);
	buf = NULL;
	{
		GUnixInputStream* unix_input = NULL;
		GUnixInputStream* _tmp15_;
		GdkPixbuf* _tmp16_ = NULL;
		GUnixInputStream* _tmp17_;
		GdkPixbuf* _tmp18_;
		GdkPixbuf* _tmp19_;
		_tmp15_ = (GUnixInputStream*) g_unix_input_stream_new (child_stdout, TRUE);
		unix_input = _tmp15_;
		_tmp17_ = unix_input;
		_tmp18_ = gdk_pixbuf_new_from_stream (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, g_input_stream_get_type (), GInputStream), NULL, &_inner_error0_);
		_tmp16_ = _tmp18_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (unix_input);
			goto __catch507_g_error;
		}
		_tmp19_ = _tmp16_;
		_tmp16_ = NULL;
		_g_object_unref0 (buf);
		buf = _tmp19_;
		_g_object_unref0 (_tmp16_);
		_g_object_unref0 (unix_input);
	}
	goto __finally507;
	__catch507_g_error:
	{
		GError* e = NULL;
		GError* _tmp20_;
		const gchar* _tmp21_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp20_ = e;
		_tmp21_ = _tmp20_->message;
		g_debug ("VideoSupport.vala:272: Error creating pixbuf: %s", _tmp21_);
		_g_object_unref0 (buf);
		buf = NULL;
		_g_error_free0 (e);
	}
	__finally507:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (buf);
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	child_status = 0;
	_tmp23_ = waitpid ((pid_t) self->priv->thumbnailer_pid, &_tmp22_, 0);
	child_status = _tmp22_;
	ret_waitpid = (gint) _tmp23_;
	if (ret_waitpid < 0) {
		g_debug ("VideoSupport.vala:280: waitpid returned error code: %d", ret_waitpid);
		_g_object_unref0 (buf);
		buf = NULL;
	} else {
		if (0 != WEXITSTATUS (child_status)) {
			g_debug ("VideoSupport.vala:283: Thumbnailer exited with error code: %d", WEXITSTATUS (child_status));
			_g_object_unref0 (buf);
			buf = NULL;
		}
	}
	g_spawn_close_pid (self->priv->thumbnailer_pid);
	self->priv->thumbnailer_pid = (GPid) 0;
	result = buf;
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	return result;
}

static gboolean
video_reader_does_file_exist (VideoReader* self)
{
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIDEO_READER (self), FALSE);
	_tmp0_ = self->priv->file;
	_tmp1_ = g_file_get_path (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_file_test (_tmp2_, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR);
	_g_free0 (_tmp2_);
	result = _tmp3_;
	return result;
}

GdkPixbuf*
video_reader_read_preview_frame (VideoReader* self)
{
	GdkPixbuf* _tmp0_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp9_;
	GdkPixbuf* _tmp10_;
	GdkPixbuf* result = NULL;
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
	_tmp0_ = self->priv->preview_frame;
	if (_tmp0_ != NULL) {
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
		_tmp1_ = self->priv->preview_frame;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		result = _tmp2_;
		return result;
	}
	if (!video_reader_does_file_exist (self)) {
		result = NULL;
		return result;
	}
	_tmp3_ = self->priv->file;
	_tmp4_ = g_file_get_path (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = video_reader_thumbnailer (self, _tmp5_);
	_g_object_unref0 (self->priv->preview_frame);
	self->priv->preview_frame = _tmp6_;
	_g_free0 (_tmp5_);
	_tmp7_ = self->priv->preview_frame;
	if (NULL == _tmp7_) {
		GdkPixbuf* _tmp8_;
		_tmp8_ = resources_get_noninterpretable_badge_pixbuf ();
		_g_object_unref0 (self->priv->preview_frame);
		self->priv->preview_frame = _tmp8_;
	}
	_tmp9_ = self->priv->preview_frame;
	_tmp10_ = _g_object_ref0 (_tmp9_);
	result = _tmp10_;
	return result;
}

gdouble
video_reader_read_clip_duration (VideoReader* self,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
	gdouble result = 0.0;
	g_return_val_if_fail (IS_VIDEO_READER (self), 0.0);
	if (self->priv->clip_duration == VIDEO_READER_UNKNOWN_CLIP_DURATION) {
		video_reader_read_internal (self, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VIDEO_ERROR) {
				gdouble _tmp0_ = -1.0;
				g_propagate_error (error, _inner_error0_);
				return _tmp0_;
			} else {
				gdouble _tmp1_ = -1.0;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp1_;
			}
		}
	}
	result = self->priv->clip_duration;
	return result;
}

VideoMetadata*
video_reader_read_metadata (VideoReader* self,
                            GError** error)
{
	VideoMetadata* metadata = NULL;
	VideoMetadata* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	VideoMetadata* result = NULL;
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
	_tmp0_ = video_metadata_new ();
	metadata = _tmp0_;
	_tmp1_ = self->priv->file;
	_tmp2_ = g_file_get_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_file_new_for_path (_tmp3_);
	_tmp5_ = _tmp4_;
	media_metadata_read_from_file (G_TYPE_CHECK_INSTANCE_CAST (metadata, TYPE_MEDIA_METADATA, MediaMetadata), _tmp5_, &_inner_error0_);
	_g_object_unref0 (_tmp5_);
	_g_free0 (_tmp3_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_media_metadata_unref0 (metadata);
		return NULL;
	}
	result = metadata;
	return result;
}

GDateTime*
video_reader_get_timestamp (VideoReader* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (IS_VIDEO_READER (self), NULL);
	_tmp0_ = self->priv->_timestamp;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

static void
video_reader_set_timestamp (VideoReader* self,
                            GDateTime* value)
{
	GDateTime* _tmp0_;
	g_return_if_fail (IS_VIDEO_READER (self));
	_tmp0_ = _g_date_time_ref0 (value);
	_g_date_time_unref0 (self->priv->_timestamp);
	self->priv->_timestamp = _tmp0_;
}

static void
value_video_reader_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_video_reader_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		video_reader_unref (value->data[0].v_pointer);
	}
}

static void
value_video_reader_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = video_reader_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_video_reader_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_video_reader_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		VideoReader * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = video_reader_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_video_reader_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	VideoReader ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = video_reader_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_video_reader (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecVideoReader* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIDEO_READER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_video_reader (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER), NULL);
	return value->data[0].v_pointer;
}

void
value_set_video_reader (GValue* value,
                        gpointer v_object)
{
	VideoReader * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		video_reader_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		video_reader_unref (old);
	}
}

void
value_take_video_reader (GValue* value,
                         gpointer v_object)
{
	VideoReader * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIDEO_READER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIDEO_READER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		video_reader_unref (old);
	}
}

static void
video_reader_class_init (VideoReaderClass * klass,
                         gpointer klass_data)
{
	video_reader_parent_class = g_type_class_peek_parent (klass);
	((VideoReaderClass *) klass)->finalize = video_reader_finalize;
	g_type_class_adjust_private_offset (klass, &VideoReader_private_offset);
}

static void
video_reader_instance_init (VideoReader * self,
                            gpointer klass)
{
	self->priv = video_reader_get_instance_private (self);
	self->priv->clip_duration = VIDEO_READER_UNKNOWN_CLIP_DURATION;
	self->priv->preview_frame = NULL;
	self->priv->file = NULL;
	self->priv->thumbnailer_pid = (GPid) 0;
	self->priv->_timestamp = NULL;
	self->ref_count = 1;
}

static void
video_reader_finalize (VideoReader * obj)
{
	VideoReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_READER, VideoReader);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->priv->preview_frame);
	_g_object_unref0 (self->priv->file);
	_g_date_time_unref0 (self->priv->_timestamp);
}

GType
video_reader_get_type (void)
{
	static volatile gsize video_reader_type_id__volatile = 0;
	if (g_once_init_enter (&video_reader_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_video_reader_init, value_video_reader_free_value, value_video_reader_copy_value, value_video_reader_peek_pointer, "p", value_video_reader_collect_value, "p", value_video_reader_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoReader), 0, (GInstanceInitFunc) video_reader_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_reader_type_id;
		video_reader_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoReader", &g_define_type_info, &g_define_type_fundamental_info, 0);
		VideoReader_private_offset = g_type_add_instance_private (video_reader_type_id, sizeof (VideoReaderPrivate));
		g_once_init_leave (&video_reader_type_id__volatile, video_reader_type_id);
	}
	return video_reader_type_id__volatile;
}

gpointer
video_reader_ref (gpointer instance)
{
	VideoReader * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
video_reader_unref (gpointer instance)
{
	VideoReader * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIDEO_READER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
video_get_instance_private (Video* self)
{
	return G_STRUCT_MEMBER_P (self, Video_private_offset);
}

static gpointer
_video_row_ref0 (gpointer self)
{
	return self ? video_row_ref (self) : NULL;
}

Video*
video_construct (GType object_type,
                 VideoRow* row)
{
	Video * self = NULL;
	VideoRow* _tmp0_;
	VideoRow* _tmp1_;
	VideoRow* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	g_return_val_if_fail (IS_VIDEO_ROW (row), NULL);
	self = (Video*) video_source_construct (object_type);
	_tmp0_ = _video_row_ref0 (row);
	_video_row_unref0 (self->priv->backing_row);
	self->priv->backing_row = _tmp0_;
	_tmp1_ = self->priv->backing_row;
	_tmp2_ = self->priv->backing_row;
	_tmp3_ = _tmp2_->title;
	_tmp4_ = media_source_prep_title (_tmp3_);
	_g_free0 (_tmp1_->title);
	_tmp1_->title = _tmp4_;
	if ((row->flags & VIDEO_FLAG_TRASH) != ((guint64) 0)) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = (row->flags & VIDEO_FLAG_OFFLINE) != ((guint64) 0);
	}
	if (_tmp5_) {
		VideoSourceCollection* _tmp6_;
		const gchar* _tmp7_;
		_tmp6_ = video_global;
		_tmp7_ = row->backlinks;
		data_source_rehydrate_backlinks (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_SOURCE_COLLECTION, SourceCollection), _tmp7_);
	}
	return self;
}

Video*
video_new (VideoRow* row)
{
	return video_construct (TYPE_VIDEO, row);
}

static gboolean
__lambda12_ (GstPluginFeature* f)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	gboolean result = FALSE;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (f, gst_plugin_feature_get_type ()), FALSE);
	_tmp0_ = gst_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (f, gst_object_get_type (), GstObject));
	_tmp1_ = _tmp0_;
	_tmp2_ = g_str_has_prefix (_tmp1_, "vaapi");
	_g_free0 (_tmp1_);
	result = _tmp2_;
	return result;
}

static gboolean
___lambda12__gst_plugin_feature_filter (GstPluginFeature* feature,
                                        gpointer self)
{
	gboolean result;
	result = __lambda12_ (feature);
	return result;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

void
video_init (ProgressMonitor monitor,
            gpointer monitor_target)
{
	gchar** args = NULL;
	gint args_length1;
	gint _args_size_;
	GstRegistry* registry = NULL;
	GstRegistry* _tmp0_;
	GstRegistry* _tmp1_;
	gint saved_state = 0;
	ConfigFacade* _tmp2_;
	ConfigFacade* _tmp3_;
	gint _tmp4_;
	GstRegistry* _tmp5_;
	GList* features = NULL;
	GstRegistry* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	VideoSourceCollection* _tmp15_;
	GeeArrayList* all = NULL;
	VideoTable* _tmp16_;
	VideoTable* _tmp17_;
	GeeArrayList* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* all_videos = NULL;
	GeeArrayList* _tmp20_;
	GeeArrayList* trashed_videos = NULL;
	GeeArrayList* _tmp21_;
	GeeArrayList* offline_videos = NULL;
	GeeArrayList* _tmp22_;
	gint count = 0;
	GeeArrayList* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	VideoSourceCollection* _tmp42_;
	GeeArrayList* _tmp43_;
	VideoSourceCollection* _tmp44_;
	GeeArrayList* _tmp45_;
	VideoSourceCollection* _tmp46_;
	GeeArrayList* _tmp47_;
	GeeCollection* _tmp48_;
	GeeCollection* _tmp49_;
	video_interpreter_state_changed = FALSE;
	video_current_state = -1;
	video_normal_regen_complete = FALSE;
	video_offline_regen_complete = FALSE;
	args = NULL;
	args_length1 = 0;
	_args_size_ = args_length1;
	gst_init ((gint*) (&args_length1), &args);
	_tmp0_ = gst_registry_get ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	registry = _tmp1_;
	_tmp2_ = config_facade_get_instance ();
	_tmp3_ = _tmp2_;
	_tmp4_ = configuration_facade_get_video_interpreter_state_cookie (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
	_g_object_unref0 (_tmp3_);
	saved_state = _tmp4_;
	_tmp5_ = registry;
	video_current_state = (gint) gst_registry_get_feature_list_cookie (_tmp5_);
	if (saved_state == CONFIG_FACADE_NO_VIDEO_INTERPRETER_STATE) {
		g_message ("VideoSupport.vala:398: interpreter state cookie not found; assuming al" \
"l video thumbnails are out of date");
		video_interpreter_state_changed = TRUE;
	} else {
		if (saved_state != video_current_state) {
			g_message ("VideoSupport.vala:401: interpreter state has changed; video thumbnails" \
" may be out of date");
			video_interpreter_state_changed = TRUE;
		}
	}
	_tmp6_ = registry;
	_tmp7_ = gst_registry_feature_filter (_tmp6_, ___lambda12__gst_plugin_feature_filter, FALSE, NULL);
	features = _tmp7_;
	_tmp8_ = features;
	{
		GList* feature_collection = NULL;
		GList* feature_it = NULL;
		feature_collection = _tmp8_;
		for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
			GstPluginFeature* _tmp9_;
			GstPluginFeature* feature = NULL;
			_tmp9_ = _g_object_ref0 ((GstPluginFeature*) feature_it->data);
			feature = _tmp9_;
			{
				GstPluginFeature* _tmp10_;
				gchar* _tmp11_;
				gchar* _tmp12_;
				GstRegistry* _tmp13_;
				GstPluginFeature* _tmp14_;
				_tmp10_ = feature;
				_tmp11_ = gst_object_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gst_object_get_type (), GstObject));
				_tmp12_ = _tmp11_;
				g_debug ("VideoSupport.vala:416: Removing registry feature %s", _tmp12_);
				_g_free0 (_tmp12_);
				_tmp13_ = registry;
				_tmp14_ = feature;
				gst_registry_remove_feature (_tmp13_, _tmp14_);
				_g_object_unref0 (feature);
			}
		}
	}
	_tmp15_ = video_source_collection_new ();
	_data_collection_unref0 (video_global);
	video_global = _tmp15_;
	_tmp16_ = video_table_get_instance ();
	_tmp17_ = _tmp16_;
	_tmp18_ = video_table_get_all (_tmp17_);
	_tmp19_ = _tmp18_;
	_database_table_unref0 (_tmp17_);
	all = _tmp19_;
	_tmp20_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	all_videos = _tmp20_;
	_tmp21_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	trashed_videos = _tmp21_;
	_tmp22_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	offline_videos = _tmp22_;
	_tmp23_ = all;
	_tmp24_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
	_tmp25_ = _tmp24_;
	count = _tmp25_;
	{
		gint ctr = 0;
		ctr = 0;
		{
			gboolean _tmp26_ = FALSE;
			_tmp26_ = TRUE;
			while (TRUE) {
				Video* video = NULL;
				GeeArrayList* _tmp28_;
				gpointer _tmp29_;
				VideoRow* _tmp30_;
				Video* _tmp31_;
				Video* _tmp32_;
				Video* _tmp34_;
				if (!_tmp26_) {
					gint _tmp27_;
					_tmp27_ = ctr;
					ctr = _tmp27_ + 1;
				}
				_tmp26_ = FALSE;
				if (!(ctr < count)) {
					break;
				}
				_tmp28_ = all;
				_tmp29_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), ctr);
				_tmp30_ = (VideoRow*) _tmp29_;
				_tmp31_ = video_new (_tmp30_);
				_tmp32_ = _tmp31_;
				_video_row_unref0 (_tmp30_);
				video = _tmp32_;
				if (video_interpreter_state_changed) {
					Video* _tmp33_;
					_tmp33_ = video;
					video_set_is_interpretable (_tmp33_, FALSE);
				}
				_tmp34_ = video;
				if (media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_MEDIA_SOURCE, MediaSource))) {
					GeeArrayList* _tmp35_;
					Video* _tmp36_;
					_tmp35_ = trashed_videos;
					_tmp36_ = video;
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp36_);
				} else {
					Video* _tmp37_;
					_tmp37_ = video;
					if (media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, TYPE_MEDIA_SOURCE, MediaSource))) {
						GeeArrayList* _tmp38_;
						Video* _tmp39_;
						_tmp38_ = offline_videos;
						_tmp39_ = video;
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp39_);
					} else {
						GeeArrayList* _tmp40_;
						Video* _tmp41_;
						_tmp40_ = all_videos;
						_tmp41_ = video;
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp41_);
					}
				}
				if (monitor != NULL) {
					monitor ((guint64) ctr, (guint64) count, TRUE, monitor_target);
				}
				_g_object_unref0 (video);
			}
		}
	}
	_tmp42_ = video_global;
	_tmp43_ = trashed_videos;
	media_source_collection_add_many_to_trash (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEE_TYPE_COLLECTION, GeeCollection));
	_tmp44_ = video_global;
	_tmp45_ = offline_videos;
	media_source_collection_add_many_to_offline (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_COLLECTION, GeeCollection));
	_tmp46_ = video_global;
	_tmp47_ = all_videos;
	_tmp48_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
	_tmp49_ = _tmp48_;
	_g_object_unref0 (_tmp49_);
	_g_object_unref0 (offline_videos);
	_g_object_unref0 (trashed_videos);
	_g_object_unref0 (all_videos);
	_g_object_unref0 (all);
	(features == NULL) ? NULL : (features = (_g_list_free__g_object_unref0_ (features), NULL));
	_g_object_unref0 (registry);
}

gboolean
video_has_interpreter_state_changed (void)
{
	gboolean result = FALSE;
	result = video_interpreter_state_changed;
	return result;
}

void
video_notify_normal_thumbs_regenerated (void)
{
	gboolean _tmp0_ = FALSE;
	if (video_normal_regen_complete) {
		return;
	}
	g_message ("VideoSupport.vala:457: normal video thumbnail regeneration completed");
	video_normal_regen_complete = TRUE;
	if (video_normal_regen_complete) {
		_tmp0_ = video_offline_regen_complete;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		video_save_interpreter_state ();
	}
}

void
video_notify_offline_thumbs_regenerated (void)
{
	gboolean _tmp0_ = FALSE;
	if (video_offline_regen_complete) {
		return;
	}
	g_message ("VideoSupport.vala:468: offline video thumbnail regeneration completed");
	video_offline_regen_complete = TRUE;
	if (video_normal_regen_complete) {
		_tmp0_ = video_offline_regen_complete;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		video_save_interpreter_state ();
	}
}

static void
video_save_interpreter_state (void)
{
	if (video_interpreter_state_changed) {
		ConfigFacade* _tmp0_;
		ConfigFacade* _tmp1_;
		g_message ("VideoSupport.vala:477: saving video interpreter state to configuration" \
" system");
		_tmp0_ = config_facade_get_instance ();
		_tmp1_ = _tmp0_;
		configuration_facade_set_video_interpreter_state_cookie (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade), video_current_state);
		_g_object_unref0 (_tmp1_);
		video_interpreter_state_changed = FALSE;
	}
}

void
video_terminate (void)
{
}

ExporterUI*
video_export_many (GeeCollection* videos,
                   ExporterCompletionCallback done,
                   gpointer done_target,
                   gboolean export_in_place)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp9_;
	gint _tmp10_;
	GFile* export_dir = NULL;
	GFile* _tmp32_;
	GFile* _tmp33_;
	ExporterUI* exporter = NULL;
	GFile* _tmp34_;
	Scaling _tmp35_ = {0};
	ExportFormatParameters _tmp36_ = {0};
	Exporter* _tmp37_;
	Exporter* _tmp38_;
	ExporterUI* _tmp39_;
	ExporterUI* _tmp40_;
	ExporterUI* _tmp41_;
	GError* _inner_error0_ = NULL;
	ExporterUI* result = NULL;
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (videos, GEE_TYPE_COLLECTION), NULL);
	_tmp0_ = gee_collection_get_size (videos);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == 0) {
		result = NULL;
		return result;
	}
	if (export_in_place) {
		ExporterUI* temp_exporter = NULL;
		Scaling _tmp2_ = {0};
		ExportFormatParameters _tmp3_ = {0};
		Exporter* _tmp4_;
		Exporter* _tmp5_;
		ExporterUI* _tmp6_;
		ExporterUI* _tmp7_;
		ExporterUI* _tmp8_;
		scaling_for_original (&_tmp2_);
		export_format_parameters_unmodified (&_tmp3_);
		_tmp4_ = exporter_new_for_temp_file (videos, &_tmp2_, &_tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = exporter_ui_new (_tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		temp_exporter = _tmp7_;
		_tmp8_ = temp_exporter;
		exporter_ui_export (_tmp8_, done, done_target);
		result = temp_exporter;
		return result;
	}
	_tmp9_ = gee_collection_get_size (videos);
	_tmp10_ = _tmp9_;
	if (_tmp10_ == 1) {
		Video* video = NULL;
		GFile* save_as = NULL;
		Video* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		GFile* _tmp20_;
		GFile* _tmp21_;
		GFile* _tmp22_;
		video = NULL;
		{
			GeeIterator* _v_it = NULL;
			GeeIterator* _tmp11_;
			_tmp11_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (videos, GEE_TYPE_ITERABLE, GeeIterable));
			_v_it = _tmp11_;
			while (TRUE) {
				GeeIterator* _tmp12_;
				Video* v = NULL;
				GeeIterator* _tmp13_;
				gpointer _tmp14_;
				Video* _tmp15_;
				Video* _tmp16_;
				_tmp12_ = _v_it;
				if (!gee_iterator_next (_tmp12_)) {
					break;
				}
				_tmp13_ = _v_it;
				_tmp14_ = gee_iterator_get (_tmp13_);
				v = (Video*) _tmp14_;
				_tmp15_ = v;
				_tmp16_ = _g_object_ref0 (_tmp15_);
				_g_object_unref0 (video);
				video = _tmp16_;
				_g_object_unref0 (v);
				break;
			}
			_g_object_unref0 (_v_it);
		}
		_tmp17_ = video;
		_tmp18_ = media_source_get_basename (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_MEDIA_SOURCE, MediaSource));
		_tmp19_ = _tmp18_;
		_tmp20_ = export_ui_choose_file (_tmp19_);
		_tmp21_ = _tmp20_;
		_g_free0 (_tmp19_);
		save_as = _tmp21_;
		_tmp22_ = save_as;
		if (_tmp22_ == NULL) {
			result = NULL;
			_g_object_unref0 (save_as);
			_g_object_unref0 (video);
			return result;
		}
		{
			AppWindow* _tmp23_;
			AppWindow* _tmp24_;
			Video* _tmp25_;
			GFile* _tmp26_;
			AppWindow* _tmp27_;
			AppWindow* _tmp28_;
			_tmp23_ = app_window_get_instance ();
			_tmp24_ = _tmp23_;
			page_window_set_busy_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_PAGE_WINDOW, PageWindow));
			_g_object_unref0 (_tmp24_);
			_tmp25_ = video;
			_tmp26_ = save_as;
			video_export (_tmp25_, _tmp26_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch508_g_error;
			}
			_tmp27_ = app_window_get_instance ();
			_tmp28_ = _tmp27_;
			page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_PAGE_WINDOW, PageWindow));
			_g_object_unref0 (_tmp28_);
		}
		goto __finally508;
		__catch508_g_error:
		{
			GError* err = NULL;
			AppWindow* _tmp29_;
			AppWindow* _tmp30_;
			GFile* _tmp31_;
			err = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp29_ = app_window_get_instance ();
			_tmp30_ = _tmp29_;
			page_window_set_normal_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_PAGE_WINDOW, PageWindow));
			_g_object_unref0 (_tmp30_);
			_tmp31_ = save_as;
			export_error_dialog (_tmp31_, FALSE);
			_g_error_free0 (err);
		}
		__finally508:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (save_as);
			_g_object_unref0 (video);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		result = NULL;
		_g_object_unref0 (save_as);
		_g_object_unref0 (video);
		return result;
	}
	_tmp32_ = export_ui_choose_dir (_ ("Export Videos"));
	export_dir = _tmp32_;
	_tmp33_ = export_dir;
	if (_tmp33_ == NULL) {
		result = NULL;
		_g_object_unref0 (export_dir);
		return result;
	}
	_tmp34_ = export_dir;
	scaling_for_original (&_tmp35_);
	export_format_parameters_unmodified (&_tmp36_);
	_tmp37_ = exporter_new (videos, _tmp34_, &_tmp35_, &_tmp36_, FALSE);
	_tmp38_ = _tmp37_;
	_tmp39_ = exporter_ui_new (_tmp38_);
	_tmp40_ = _tmp39_;
	_g_object_unref0 (_tmp38_);
	exporter = _tmp40_;
	_tmp41_ = exporter;
	exporter_ui_export (_tmp41_, done, done_target);
	result = exporter;
	_g_object_unref0 (export_dir);
	return result;
}

static void
video_real_commit_backlinks (DataSource* base,
                             SourceCollection* sources,
                             const gchar* backlinks)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
	{
		VideoTable* _tmp0_;
		VideoTable* _tmp1_;
		VideoID _tmp2_ = {0};
		_tmp0_ = video_table_get_instance ();
		_tmp1_ = _tmp0_;
		video_get_video_id (self, &_tmp2_);
		video_table_update_backlinks (_tmp1_, &_tmp2_, backlinks, &_inner_error0_);
		_database_table_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DATABASE_ERROR) {
				goto __catch509_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_lock (&self->priv->__lock_backing_row);
			{
				VideoRow* _tmp4_;
				gchar* _tmp5_;
				_tmp4_ = self->priv->backing_row;
				_tmp5_ = g_strdup (backlinks);
				_g_free0 (_tmp4_->backlinks);
				_tmp4_->backlinks = _tmp5_;
			}
			__finally510:
			{
				VideoRow* _tmp6_;
				_tmp6_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DATABASE_ERROR) {
					goto __catch509_database_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	goto __finally509;
	__catch509_database_error:
	{
		GError* err = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
		_tmp8_ = _tmp7_;
		_tmp9_ = err;
		_tmp10_ = _tmp9_->message;
		g_warning ("VideoSupport.vala:543: Unable to update link state for %s: %s", _tmp8_, _tmp10_);
		_g_free0 (_tmp8_);
		_g_error_free0 (err);
	}
	__finally509:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gboolean
video_real_set_event_id (MediaSource* base,
                         EventID* event_id)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	g_return_val_if_fail (event_id != NULL, FALSE);
	{
		VideoRow* _tmp0_;
		gboolean _tmp11_ = FALSE;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			gboolean committed = FALSE;
			VideoTable* _tmp1_;
			VideoTable* _tmp2_;
			VideoRow* _tmp3_;
			VideoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_;
			_tmp1_ = video_table_get_instance ();
			_tmp2_ = _tmp1_;
			_tmp3_ = self->priv->backing_row;
			_tmp4_ = _tmp3_->video_id;
			_tmp5_ = *event_id;
			_tmp6_ = video_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
			_database_table_unref0 (_tmp2_);
			committed = _tmp6_;
			if (committed) {
				VideoRow* _tmp7_;
				EventID _tmp8_;
				_tmp7_ = self->priv->backing_row;
				_tmp8_ = *event_id;
				_tmp7_->event_id = _tmp8_;
			}
			result = committed;
			{
				VideoRow* _tmp9_;
				_tmp9_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally511:
		{
			VideoRow* _tmp10_;
			_tmp10_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp11_;
	}
}

gboolean
video_is_duplicate (GFile* file,
                    const gchar* full_md5)
{
	gboolean _tmp0_ = FALSE;
	VideoTable* _tmp1_;
	VideoTable* _tmp2_;
	gboolean _tmp3_;
	gboolean result = FALSE;
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
	if (file != NULL) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = full_md5 != NULL;
	}
	_vala_assert (_tmp0_, "file != null || full_md5 != null");
	_tmp1_ = video_table_get_instance ();
	_tmp2_ = _tmp1_;
	_tmp3_ = video_table_has_duplicate (_tmp2_, file, full_md5);
	_database_table_unref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

ImportResult
video_import_create (VideoImportParams* params,
                     Video* * video)
{
	Video* _vala_video = NULL;
	VideoRow* _tmp6_;
	Video* _tmp7_;
	GError* _inner_error0_ = NULL;
	ImportResult result = 0;
	g_return_val_if_fail (IS_VIDEO_IMPORT_PARAMS (params), 0);
	_g_object_unref0 (_vala_video);
	_vala_video = NULL;
	{
		VideoID _tmp0_ = {0};
		VideoTable* _tmp1_;
		VideoTable* _tmp2_;
		VideoRow* _tmp3_;
		VideoID _tmp4_ = {0};
		VideoID _tmp5_;
		_tmp1_ = video_table_get_instance ();
		_tmp2_ = _tmp1_;
		_tmp3_ = params->row;
		video_table_add (_tmp2_, _tmp3_, &_tmp4_, &_inner_error0_);
		_tmp5_ = _tmp4_;
		_database_table_unref0 (_tmp2_);
		_tmp0_ = _tmp5_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DATABASE_ERROR) {
				goto __catch512_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return 0;
		}
		if (video_id_is_invalid (&_tmp0_)) {
			result = IMPORT_RESULT_DATABASE_ERROR;
			if (video) {
				*video = _vala_video;
			} else {
				_g_object_unref0 (_vala_video);
			}
			return result;
		}
	}
	goto __finally512;
	__catch512_database_error:
	{
		GError* err = NULL;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		result = IMPORT_RESULT_DATABASE_ERROR;
		_g_error_free0 (err);
		if (video) {
			*video = _vala_video;
		} else {
			_g_object_unref0 (_vala_video);
		}
		return result;
	}
	__finally512:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return 0;
	}
	_tmp6_ = params->row;
	_tmp7_ = video_new (_tmp6_);
	_g_object_unref0 (_vala_video);
	_vala_video = _tmp7_;
	result = IMPORT_RESULT_SUCCESS;
	if (video) {
		*video = _vala_video;
	} else {
		_g_object_unref0 (_vala_video);
	}
	return result;
}

void
video_import_failed (Video* video)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (IS_VIDEO (video));
	{
		VideoTable* _tmp0_;
		VideoTable* _tmp1_;
		VideoID _tmp2_ = {0};
		_tmp0_ = video_table_get_instance ();
		_tmp1_ = _tmp0_;
		video_get_video_id (video, &_tmp2_);
		video_table_remove (_tmp1_, &_tmp2_, &_inner_error0_);
		_database_table_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DATABASE_ERROR) {
				goto __catch513_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally513;
	__catch513_database_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = err;
		app_window_database_error (_tmp3_);
		_g_error_free0 (err);
	}
	__finally513:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static BackingFileState**
video_real_get_backing_files_state (MediaSource* base,
                                    gint* result_length1)
{
	Video * self;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp10_;
	gint _tmp10__length1;
	GError* _inner_error0_ = NULL;
	BackingFileState** result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = g_new0 (BackingFileState*, 1 + 1);
	backing = _tmp0_;
	backing_length1 = 1;
	_backing_size_ = backing_length1;
	{
		VideoRow* _tmp1_;
		_tmp1_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp2_;
			const gchar* _tmp3_;
			VideoRow* _tmp4_;
			VideoRow* _tmp5_;
			VideoRow* _tmp6_;
			const gchar* _tmp7_;
			BackingFileState* _tmp8_;
			_tmp2_ = self->priv->backing_row;
			_tmp3_ = _tmp2_->filepath;
			_tmp4_ = self->priv->backing_row;
			_tmp5_ = self->priv->backing_row;
			_tmp6_ = self->priv->backing_row;
			_tmp7_ = _tmp6_->md5;
			_tmp8_ = backing_file_state_new (_tmp3_, _tmp4_->filesize, _tmp5_->timestamp, _tmp7_);
			_backing_file_state_unref0 (backing[0]);
			backing[0] = _tmp8_;
		}
		__finally514:
		{
			VideoRow* _tmp9_;
			_tmp9_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp10_ = backing;
	_tmp10__length1 = backing_length1;
	if (result_length1) {
		*result_length1 = _tmp10__length1;
	}
	result = _tmp10_;
	return result;
}

static GdkPixbuf*
video_real_get_thumbnail (ThumbnailSource* base,
                          gint scale,
                          GError** error)
{
	Video * self;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp1_ = thumbnail_cache_fetch (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), scale, &_inner_error0_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_g_object_unref0 (_tmp0_);
	return result;
}

static gchar*
video_real_get_master_md5 (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->md5;
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			{
				VideoRow* _tmp4_;
				_tmp4_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally515:
		{
			VideoRow* _tmp5_;
			_tmp5_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

static GdkPixbuf*
video_real_get_preview_pixbuf (MediaSource* base,
                               Scaling* scaling,
                               GError** error)
{
	Video * self;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	g_return_val_if_fail (scaling != NULL, NULL);
	_tmp0_ = thumbnail_source_get_thumbnail (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error0_);
	pixbuf = _tmp0_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_NEAREST, TRUE);
	result = _tmp1_;
	_g_object_unref0 (pixbuf);
	return result;
}

static GdkPixbuf*
video_real_create_thumbnail (ThumbnailSource* base,
                             gint scale,
                             GError** error)
{
	Video * self;
	VideoReader* reader = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	VideoReader* _tmp2_;
	VideoReader* _tmp3_;
	GdkPixbuf* frame = NULL;
	VideoReader* _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_ = NULL;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
	_tmp1_ = _tmp0_;
	_tmp2_ = video_reader_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_object_unref0 (_tmp1_);
	reader = _tmp3_;
	_tmp4_ = reader;
	_tmp5_ = video_reader_read_preview_frame (_tmp4_);
	frame = _tmp5_;
	_tmp7_ = frame;
	if (_tmp7_ != NULL) {
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
		_tmp8_ = frame;
		_tmp9_ = _g_object_ref0 (_tmp8_);
		_g_object_unref0 (_tmp6_);
		_tmp6_ = _tmp9_;
	} else {
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
		_tmp10_ = resources_get_noninterpretable_badge_pixbuf ();
		_tmp11_ = _tmp10_;
		_tmp12_ = gdk_pixbuf_copy (_tmp11_);
		_g_object_unref0 (_tmp6_);
		_tmp6_ = _tmp12_;
		_g_object_unref0 (_tmp11_);
	}
	result = _tmp6_;
	_g_object_unref0 (frame);
	_video_reader_unref0 (reader);
	return result;
}

static gchar*
video_real_get_typename (DataSource* base)
{
	Video * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = g_strdup (VIDEO_TYPENAME);
	result = _tmp0_;
	return result;
}

static gint64
video_real_get_instance_id (DataSource* base)
{
	Video * self;
	VideoID _tmp0_ = {0};
	gint64 result = 0LL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	video_get_video_id (self, &_tmp0_);
	result = _tmp0_.id;
	return result;
}

static void
video_real_get_import_id (MediaSource* base,
                          ImportID* result)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			ImportID _tmp2_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->import_id;
			*result = _tmp2_;
			{
				VideoRow* _tmp3_;
				_tmp3_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return;
		}
		__finally516:
		{
			VideoRow* _tmp4_;
			_tmp4_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static PhotoFileFormat
video_real_get_preferred_thumbnail_format (ThumbnailSource* base)
{
	Video * self;
	PhotoFileFormat result = 0;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	result = photo_file_format_get_system_default_format ();
	return result;
}

static gchar*
video_real_get_title (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->title;
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			{
				VideoRow* _tmp4_;
				_tmp4_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally517:
		{
			VideoRow* _tmp5_;
			_tmp5_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

static void
video_real_set_title (MediaSource* base,
                      const gchar* title)
{
	Video * self;
	gchar* new_title = NULL;
	gchar* _tmp0_;
	Alteration* _tmp18_;
	Alteration* _tmp19_;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = media_source_prep_title (title);
	new_title = _tmp0_;
	{
		VideoRow* _tmp1_;
		_tmp1_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			VideoRow* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			_tmp2_ = self->priv->backing_row;
			_tmp3_ = _tmp2_->title;
			_tmp4_ = new_title;
			if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
				{
					VideoRow* _tmp5_;
					_tmp5_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				_g_free0 (new_title);
				return;
			}
			{
				VideoTable* _tmp6_;
				VideoTable* _tmp7_;
				VideoRow* _tmp8_;
				VideoID _tmp9_;
				const gchar* _tmp10_;
				_tmp6_ = video_table_get_instance ();
				_tmp7_ = _tmp6_;
				_tmp8_ = self->priv->backing_row;
				_tmp9_ = _tmp8_->video_id;
				_tmp10_ = new_title;
				video_table_set_title (_tmp7_, &_tmp9_, _tmp10_, &_inner_error0_);
				_database_table_unref0 (_tmp7_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == DATABASE_ERROR) {
						goto __catch519_database_error;
					}
					{
						VideoRow* _tmp11_;
						_tmp11_ = self->priv->backing_row;
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
					}
					_g_free0 (new_title);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			goto __finally519;
			__catch519_database_error:
			{
				GError* e = NULL;
				GError* _tmp12_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp12_ = e;
				app_window_database_error (_tmp12_);
				_g_error_free0 (e);
				{
					VideoRow* _tmp13_;
					_tmp13_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				_g_free0 (new_title);
				return;
			}
			__finally519:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (new_title);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_tmp14_ = self->priv->backing_row;
			_tmp15_ = new_title;
			_tmp16_ = g_strdup (_tmp15_);
			_g_free0 (_tmp14_->title);
			_tmp14_->title = _tmp16_;
		}
		__finally518:
		{
			VideoRow* _tmp17_;
			_tmp17_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (new_title);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp18_ = alteration_new ("metadata", "name");
	_tmp19_ = _tmp18_;
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp19_);
	_alteration_unref0 (_tmp19_);
	_g_free0 (new_title);
}

static gchar*
video_real_get_comment (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->comment;
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			{
				VideoRow* _tmp4_;
				_tmp4_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally520:
		{
			VideoRow* _tmp5_;
			_tmp5_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

static gboolean
video_real_set_comment (MediaSource* base,
                        const gchar* comment)
{
	Video * self;
	gchar* new_comment = NULL;
	gchar* _tmp0_;
	Alteration* _tmp21_;
	Alteration* _tmp22_;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = media_source_prep_title (comment);
	new_comment = _tmp0_;
	{
		VideoRow* _tmp1_;
		_tmp1_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp2_;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			VideoRow* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			_tmp2_ = self->priv->backing_row;
			_tmp3_ = _tmp2_->comment;
			_tmp4_ = new_comment;
			if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
				result = TRUE;
				{
					VideoRow* _tmp5_;
					_tmp5_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				_g_free0 (new_comment);
				return result;
			}
			{
				VideoTable* _tmp6_;
				VideoTable* _tmp7_;
				VideoRow* _tmp8_;
				VideoID _tmp9_;
				const gchar* _tmp10_;
				_tmp6_ = video_table_get_instance ();
				_tmp7_ = _tmp6_;
				_tmp8_ = self->priv->backing_row;
				_tmp9_ = _tmp8_->video_id;
				_tmp10_ = new_comment;
				video_table_set_comment (_tmp7_, &_tmp9_, _tmp10_, &_inner_error0_);
				_database_table_unref0 (_tmp7_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					gboolean _tmp12_ = FALSE;
					if (_inner_error0_->domain == DATABASE_ERROR) {
						goto __catch522_database_error;
					}
					{
						VideoRow* _tmp11_;
						_tmp11_ = self->priv->backing_row;
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
					}
					_g_free0 (new_comment);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp12_;
				}
			}
			goto __finally522;
			__catch522_database_error:
			{
				GError* e = NULL;
				GError* _tmp13_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp13_ = e;
				app_window_database_error (_tmp13_);
				result = FALSE;
				_g_error_free0 (e);
				{
					VideoRow* _tmp14_;
					_tmp14_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				_g_free0 (new_comment);
				return result;
			}
			__finally522:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				gboolean _tmp15_ = FALSE;
				_g_free0 (new_comment);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp15_;
			}
			_tmp16_ = self->priv->backing_row;
			_tmp17_ = new_comment;
			_tmp18_ = g_strdup (_tmp17_);
			_g_free0 (_tmp16_->comment);
			_tmp16_->comment = _tmp18_;
		}
		__finally521:
		{
			VideoRow* _tmp19_;
			_tmp19_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			gboolean _tmp20_ = FALSE;
			_g_free0 (new_comment);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp20_;
		}
	}
	_tmp21_ = alteration_new ("metadata", "comment");
	_tmp22_ = _tmp21_;
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp22_);
	_alteration_unref0 (_tmp22_);
	result = TRUE;
	_g_free0 (new_comment);
	return result;
}

static Rating
video_real_get_rating (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	Rating result = 0;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			Rating _tmp2_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->rating;
			result = _tmp2_;
			{
				VideoRow* _tmp3_;
				_tmp3_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally523:
		{
			VideoRow* _tmp4_;
			_tmp4_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return 0;
	}
}

static void
video_real_set_rating (MediaSource* base,
                       Rating rating)
{
	Video * self;
	Alteration* _tmp13_;
	Alteration* _tmp14_;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			gboolean _tmp1_ = FALSE;
			VideoRow* _tmp11_;
			if (!rating_is_valid (rating)) {
				_tmp1_ = TRUE;
			} else {
				VideoRow* _tmp2_;
				Rating _tmp3_;
				_tmp2_ = self->priv->backing_row;
				_tmp3_ = _tmp2_->rating;
				_tmp1_ = rating == _tmp3_;
			}
			if (_tmp1_) {
				{
					VideoRow* _tmp4_;
					_tmp4_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				return;
			}
			{
				VideoTable* _tmp5_;
				VideoTable* _tmp6_;
				VideoID _tmp7_ = {0};
				_tmp5_ = video_table_get_instance ();
				_tmp6_ = _tmp5_;
				video_get_video_id (self, &_tmp7_);
				video_table_set_rating (_tmp6_, &_tmp7_, rating, &_inner_error0_);
				_database_table_unref0 (_tmp6_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == DATABASE_ERROR) {
						goto __catch525_database_error;
					}
					{
						VideoRow* _tmp8_;
						_tmp8_ = self->priv->backing_row;
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
			goto __finally525;
			__catch525_database_error:
			{
				GError* e = NULL;
				GError* _tmp9_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp9_ = e;
				app_window_database_error (_tmp9_);
				_g_error_free0 (e);
				{
					VideoRow* _tmp10_;
					_tmp10_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				return;
			}
			__finally525:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_tmp11_ = self->priv->backing_row;
			_tmp11_->rating = rating;
		}
		__finally524:
		{
			VideoRow* _tmp12_;
			_tmp12_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp13_ = alteration_new ("metadata", "rating");
	_tmp14_ = _tmp13_;
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp14_);
	_alteration_unref0 (_tmp14_);
}

static void
video_real_increase_rating (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			Rating _tmp2_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->rating;
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_increase (_tmp2_));
		}
		__finally526:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
video_real_decrease_rating (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			Rating _tmp2_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->rating;
			media_source_set_rating (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), rating_decrease (_tmp2_));
		}
		__finally527:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static gboolean
video_real_is_trashed (MediaSource* base)
{
	Video * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	result = video_is_flag_set (self, VIDEO_FLAG_TRASH);
	return result;
}

static gboolean
video_real_is_offline (Monitorable* base)
{
	Video * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	result = video_is_flag_set (self, VIDEO_FLAG_OFFLINE);
	return result;
}

static void
video_real_mark_offline (Monitorable* base)
{
	Video * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	video_add_flags (self, VIDEO_FLAG_OFFLINE, NULL);
}

static void
video_real_mark_online (Monitorable* base)
{
	Video * self;
	gboolean _tmp0_ = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	video_remove_flags (self, VIDEO_FLAG_OFFLINE, NULL);
	if (!video_get_is_interpretable (self)) {
		_tmp0_ = video_has_interpreter_state_changed ();
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		VideoInterpretableResults* _tmp1_;
		VideoInterpretableResults* _tmp2_;
		_tmp1_ = video_check_is_interpretable (self);
		_tmp2_ = _tmp1_;
		video_interpretable_results_foreground_finish (_tmp2_);
		_video_interpretable_results_unref0 (_tmp2_);
	}
}

static void
video_real_trash (MediaSource* base)
{
	Video * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	video_add_flags (self, VIDEO_FLAG_TRASH, NULL);
}

static void
video_real_untrash (MediaSource* base)
{
	Video * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	video_remove_flags (self, VIDEO_FLAG_TRASH, NULL);
}

static gboolean
video_real_is_flagged (Flaggable* base)
{
	Video * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	result = video_is_flag_set (self, VIDEO_FLAG_FLAGGED);
	return result;
}

static void
video_real_mark_flagged (Flaggable* base)
{
	Video * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = alteration_new ("metadata", "flagged");
	_tmp1_ = _tmp0_;
	video_add_flags (self, VIDEO_FLAG_FLAGGED, _tmp1_);
	_alteration_unref0 (_tmp1_);
}

static void
video_real_mark_unflagged (Flaggable* base)
{
	Video * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = alteration_new ("metadata", "flagged");
	_tmp1_ = _tmp0_;
	video_remove_flags (self, VIDEO_FLAG_FLAGGED, _tmp1_);
	_alteration_unref0 (_tmp1_);
}

static void
video_real_get_event_id (MediaSource* base,
                         EventID* result)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			EventID _tmp2_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->event_id;
			*result = _tmp2_;
			{
				VideoRow* _tmp3_;
				_tmp3_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return;
		}
		__finally528:
		{
			VideoRow* _tmp4_;
			_tmp4_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gchar*
video_real_to_string (DataObject* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			VideoID _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			VideoRow* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->video_id;
			_tmp3_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp2_.id);
			_tmp4_ = _tmp3_;
			_tmp5_ = self->priv->backing_row;
			_tmp6_ = _tmp5_->filepath;
			_tmp7_ = g_strdup_printf ("[%s] %s", _tmp4_, _tmp6_);
			_tmp8_ = _tmp7_;
			_g_free0 (_tmp4_);
			result = _tmp8_;
			{
				VideoRow* _tmp9_;
				_tmp9_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally529:
		{
			VideoRow* _tmp10_;
			_tmp10_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

void
video_get_video_id (Video* self,
                    VideoID* result)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (IS_VIDEO (self));
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			VideoID _tmp2_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->video_id;
			*result = _tmp2_;
			{
				VideoRow* _tmp3_;
				_tmp3_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return;
		}
		__finally530:
		{
			VideoRow* _tmp4_;
			_tmp4_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static time_t
video_real_get_exposure_time (Dateable* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	time_t result = 0;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		time_t _tmp4_ = 0;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			result = _tmp1_->exposure_time;
			{
				VideoRow* _tmp2_;
				_tmp2_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally531:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp4_;
	}
}

static void
video_real_set_exposure_time (Dateable* base,
                              time_t time)
{
	Video * self;
	Alteration* _tmp9_;
	Alteration* _tmp10_;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp7_;
			{
				VideoTable* _tmp1_;
				VideoTable* _tmp2_;
				VideoRow* _tmp3_;
				VideoID _tmp4_;
				_tmp1_ = video_table_get_instance ();
				_tmp2_ = _tmp1_;
				_tmp3_ = self->priv->backing_row;
				_tmp4_ = _tmp3_->video_id;
				video_table_set_exposure_time (_tmp2_, &_tmp4_, time, &_inner_error0_);
				_database_table_unref0 (_tmp2_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch533_g_error;
				}
			}
			goto __finally533;
			__catch533_g_error:
			{
				GError* e = NULL;
				GError* _tmp5_;
				const gchar* _tmp6_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp5_ = e;
				_tmp6_ = _tmp5_->message;
				g_debug ("VideoSupport.vala:805: Warning - %s", _tmp6_);
				_g_error_free0 (e);
			}
			__finally533:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_tmp7_ = self->priv->backing_row;
			_tmp7_->exposure_time = time;
		}
		__finally532:
		{
			VideoRow* _tmp8_;
			_tmp8_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp9_ = alteration_new ("metadata", "exposure-time");
	_tmp10_ = _tmp9_;
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp10_);
	_alteration_unref0 (_tmp10_);
}

void
video_get_frame_dimensions (Video* self,
                            Dimensions* result)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (IS_VIDEO (self));
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			VideoRow* _tmp2_;
			Dimensions _tmp3_ = {0};
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = self->priv->backing_row;
			dimensions_init (&_tmp3_, _tmp1_->width, _tmp2_->height);
			*result = _tmp3_;
			{
				VideoRow* _tmp4_;
				_tmp4_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return;
		}
		__finally534:
		{
			VideoRow* _tmp5_;
			_tmp5_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
video_real_get_dimensions (MediaSource* base,
                           PhotoException disallowed_steps,
                           Dimensions* result)
{
	Video * self;
	Dimensions _tmp0_ = {0};
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	video_get_frame_dimensions (self, &_tmp0_);
	*result = _tmp0_;
	return;
}

static guint64
video_real_get_filesize (MediaSource* base)
{
	Video * self;
	guint64 result = 0ULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	result = media_source_get_master_filesize (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
	return result;
}

static guint64
video_real_get_master_filesize (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		guint64 _tmp4_ = 0ULL;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			result = (guint64) _tmp1_->filesize;
			{
				VideoRow* _tmp2_;
				_tmp2_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally535:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp4_;
	}
}

static time_t
video_real_get_timestamp (MediaSource* base)
{
	Video * self;
	GError* _inner_error0_ = NULL;
	time_t result = 0;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	{
		VideoRow* _tmp0_;
		time_t _tmp4_ = 0;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			result = _tmp1_->timestamp;
			{
				VideoRow* _tmp2_;
				_tmp2_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally536:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp4_;
	}
}

static void
video_real_set_master_timestamp (Monitorable* base,
                                 GFileInfo* info)
{
	Video * self;
	GTimeVal time_val = {0};
	GTimeVal _tmp0_ = {0};
	Alteration* _tmp14_;
	Alteration* _tmp15_;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
	g_file_info_get_modification_time (info, &_tmp0_);
	time_val = _tmp0_;
	{
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			g_rec_mutex_lock (&self->priv->__lock_backing_row);
			{
				VideoRow* _tmp2_;
				GTimeVal _tmp3_;
				VideoTable* _tmp5_;
				VideoTable* _tmp6_;
				VideoRow* _tmp7_;
				VideoID _tmp8_;
				GTimeVal _tmp9_;
				VideoRow* _tmp10_;
				GTimeVal _tmp11_;
				_tmp2_ = self->priv->backing_row;
				_tmp3_ = time_val;
				if (_tmp2_->timestamp == ((time_t) _tmp3_.tv_sec)) {
					{
						GError* _inner_error0_ = NULL;
						VideoRow* _tmp4_;
						_tmp4_ = self->priv->backing_row;
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
					}
					return;
				}
				_tmp5_ = video_table_get_instance ();
				_tmp6_ = _tmp5_;
				_tmp7_ = self->priv->backing_row;
				_tmp8_ = _tmp7_->video_id;
				_tmp9_ = time_val;
				video_table_set_timestamp (_tmp6_, &_tmp8_, (time_t) _tmp9_.tv_sec, &_inner_error0_);
				_database_table_unref0 (_tmp6_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __finally538;
				}
				_tmp10_ = self->priv->backing_row;
				_tmp11_ = time_val;
				_tmp10_->timestamp = (time_t) _tmp11_.tv_sec;
			}
			__finally538:
			{
				GError* _inner_error1_ = NULL;
				VideoRow* _tmp12_;
				_tmp12_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DATABASE_ERROR) {
					goto __catch537_database_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	goto __finally537;
	__catch537_database_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp13_ = err;
		app_window_database_error (_tmp13_);
		_g_error_free0 (err);
		return;
	}
	__finally537:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp14_ = alteration_new ("metadata", "master-timestamp");
	_tmp15_ = _tmp14_;
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp15_);
	_alteration_unref0 (_tmp15_);
}

gchar*
video_get_filename (Video* self)
{
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
	g_return_val_if_fail (IS_VIDEO (self), NULL);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
			_tmp1_ = self->priv->backing_row;
			_tmp2_ = _tmp1_->filepath;
			_tmp3_ = g_strdup (_tmp2_);
			result = _tmp3_;
			{
				VideoRow* _tmp4_;
				_tmp4_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally539:
		{
			VideoRow* _tmp5_;
			_tmp5_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
}

static GFile*
video_real_get_file (MediaSource* base)
{
	Video * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = video_get_filename (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_new_for_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	result = _tmp3_;
	return result;
}

static GFile*
video_real_get_master_file (MediaSource* base)
{
	Video * self;
	GFile* _tmp0_;
	GFile* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	_tmp0_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
	result = _tmp0_;
	return result;
}

void
video_export (Video* self,
              GFile* dest_file,
              GError** error)
{
	GFile* source_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (IS_VIDEO (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dest_file, g_file_get_type ()));
	_tmp0_ = video_get_filename (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_file_new_for_path (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	source_file = _tmp3_;
	g_file_copy (source_file, dest_file, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		_g_object_unref0 (source_file);
		return;
	}
	_g_object_unref0 (source_file);
}

gdouble
video_get_clip_duration (Video* self)
{
	GError* _inner_error0_ = NULL;
	gdouble result = 0.0;
	g_return_val_if_fail (IS_VIDEO (self), 0.0);
	{
		VideoRow* _tmp0_;
		gdouble _tmp4_ = -1.0;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			result = _tmp1_->clip_duration;
			{
				VideoRow* _tmp2_;
				_tmp2_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally540:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp4_;
	}
}

gboolean
video_get_is_interpretable (Video* self)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIDEO (self), FALSE);
	{
		VideoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			result = _tmp1_->is_interpretable;
			{
				VideoRow* _tmp2_;
				_tmp2_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally541:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp4_;
	}
}

static void
video_set_is_interpretable (Video* self,
                            gboolean is_interpretable)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (IS_VIDEO (self));
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			VideoRow* _tmp3_;
			_tmp1_ = self->priv->backing_row;
			if (_tmp1_->is_interpretable == is_interpretable) {
				{
					VideoRow* _tmp2_;
					_tmp2_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				return;
			}
			_tmp3_ = self->priv->backing_row;
			_tmp3_->is_interpretable = is_interpretable;
		}
		__finally542:
		{
			VideoRow* _tmp4_;
			_tmp4_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	{
		VideoTable* _tmp5_;
		VideoTable* _tmp6_;
		VideoID _tmp7_ = {0};
		_tmp5_ = video_table_get_instance ();
		_tmp6_ = _tmp5_;
		video_get_video_id (self, &_tmp7_);
		video_table_update_is_interpretable (_tmp6_, &_tmp7_, is_interpretable, &_inner_error0_);
		_database_table_unref0 (_tmp6_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DATABASE_ERROR) {
				goto __catch543_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally543;
	__catch543_database_error:
	{
		GError* e = NULL;
		GError* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = e;
		app_window_database_error (_tmp8_);
		_g_error_free0 (e);
	}
	__finally543:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

VideoInterpretableResults*
video_check_is_interpretable (Video* self)
{
	VideoInterpretableResults* results = NULL;
	VideoInterpretableResults* _tmp0_;
	gdouble clip_duration = 0.0;
	GdkPixbuf* preview_frame = NULL;
	VideoReader* backing_file_reader = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	VideoReader* _tmp3_;
	VideoReader* _tmp4_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	VideoInterpretableResults* _tmp20_;
	VideoInterpretableResults* _tmp21_;
	VideoInterpretableResults* _tmp22_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* _tmp24_;
	GError* _inner_error0_ = NULL;
	VideoInterpretableResults* result = NULL;
	g_return_val_if_fail (IS_VIDEO (self), NULL);
	_tmp0_ = video_interpretable_results_new (self);
	results = _tmp0_;
	clip_duration = -1.0;
	preview_frame = NULL;
	_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
	_tmp2_ = _tmp1_;
	_tmp3_ = video_reader_new (_tmp2_);
	_tmp4_ = _tmp3_;
	_g_object_unref0 (_tmp2_);
	backing_file_reader = _tmp4_;
	{
		gdouble _tmp5_ = 0.0;
		VideoReader* _tmp6_;
		VideoReader* _tmp7_;
		GdkPixbuf* _tmp8_;
		_tmp6_ = backing_file_reader;
		_tmp5_ = video_reader_read_clip_duration (_tmp6_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == VIDEO_ERROR) {
				goto __catch544_video_error;
			}
			_video_reader_unref0 (backing_file_reader);
			_g_object_unref0 (preview_frame);
			_video_interpretable_results_unref0 (results);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		clip_duration = _tmp5_;
		_tmp7_ = backing_file_reader;
		_tmp8_ = video_reader_read_preview_frame (_tmp7_);
		_g_object_unref0 (preview_frame);
		preview_frame = _tmp8_;
	}
	goto __finally544;
	__catch544_video_error:
	{
		GError* e = NULL;
		VideoInterpretableResults* _tmp9_;
		VideoInterpretableResults* _tmp10_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp9_ = results;
		_tmp9_->update_interpretable = video_get_is_interpretable (self);
		_tmp10_ = results;
		_tmp10_->is_interpretable = FALSE;
		result = results;
		_g_error_free0 (e);
		_video_reader_unref0 (backing_file_reader);
		_g_object_unref0 (preview_frame);
		return result;
	}
	__finally544:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_video_reader_unref0 (backing_file_reader);
		_g_object_unref0 (preview_frame);
		_video_interpretable_results_unref0 (results);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	if (video_get_is_interpretable (self)) {
		VideoInterpretableResults* _tmp11_;
		VideoInterpretableResults* _tmp12_;
		_tmp11_ = results;
		_tmp11_->update_interpretable = FALSE;
		_tmp12_ = results;
		_tmp12_->is_interpretable = TRUE;
		result = results;
		_video_reader_unref0 (backing_file_reader);
		_g_object_unref0 (preview_frame);
		return result;
	}
	_tmp13_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
	_tmp14_ = _tmp13_;
	_tmp15_ = g_file_get_basename (_tmp14_);
	_tmp16_ = _tmp15_;
	g_debug ("VideoSupport.vala:936: video %s has become interpretable", _tmp16_);
	_g_free0 (_tmp16_);
	_g_object_unref0 (_tmp14_);
	{
		VideoRow* _tmp17_;
		_tmp17_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp18_;
			_tmp18_ = self->priv->backing_row;
			_tmp18_->clip_duration = clip_duration;
		}
		__finally545:
		{
			VideoRow* _tmp19_;
			_tmp19_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_video_reader_unref0 (backing_file_reader);
			_g_object_unref0 (preview_frame);
			_video_interpretable_results_unref0 (results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp20_ = results;
	_tmp20_->update_interpretable = TRUE;
	_tmp21_ = results;
	_tmp21_->is_interpretable = TRUE;
	_tmp22_ = results;
	_tmp23_ = preview_frame;
	_tmp24_ = _g_object_ref0 (_tmp23_);
	_g_object_unref0 (_tmp22_->new_thumbnail);
	_tmp22_->new_thumbnail = _tmp24_;
	result = results;
	_video_reader_unref0 (backing_file_reader);
	_g_object_unref0 (preview_frame);
	return result;
}

static void
video_real_destroy (DataSource* base)
{
	Video * self;
	VideoID video_id = {0};
	VideoID _tmp0_ = {0};
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	video_get_video_id (self, &_tmp0_);
	video_id = _tmp0_;
	thumbnail_cache_remove (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
	{
		VideoTable* _tmp1_;
		VideoTable* _tmp2_;
		VideoID _tmp3_;
		_tmp1_ = video_table_get_instance ();
		_tmp2_ = _tmp1_;
		_tmp3_ = video_id;
		video_table_remove (_tmp2_, &_tmp3_, &_inner_error0_);
		_database_table_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == DATABASE_ERROR) {
				goto __catch546_database_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	goto __finally546;
	__catch546_database_error:
	{
		GError* err = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject));
		_tmp5_ = _tmp4_;
		g_error ("VideoSupport.vala:958: failed to remove video %s from video table", _tmp5_);
		_g_free0 (_tmp5_);
		_g_error_free0 (err);
	}
	__finally546:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	DATA_SOURCE_CLASS (video_parent_class)->destroy (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_VIDEO_SOURCE, VideoSource), TYPE_DATA_SOURCE, DataSource));
}

static gboolean
video_real_internal_delete_backing (DataSource* base,
                                    GError** error)
{
	Video * self;
	gboolean ret = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	ret = media_source_delete_original_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
	_tmp1_ = DATA_SOURCE_CLASS (video_parent_class)->internal_delete_backing (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_VIDEO_SOURCE, VideoSource), TYPE_DATA_SOURCE, DataSource), &_inner_error0_);
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gboolean _tmp2_ = FALSE;
		g_propagate_error (error, _inner_error0_);
		return _tmp2_;
	}
	if (_tmp1_) {
		_tmp0_ = ret;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static void
video_notify_flags_altered (Video* self,
                            Alteration* additional_alteration)
{
	Alteration* alteration = NULL;
	Alteration* _tmp0_;
	Alteration* _tmp3_;
	g_return_if_fail (IS_VIDEO (self));
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
	_tmp0_ = alteration_new ("metadata", "flags");
	alteration = _tmp0_;
	if (additional_alteration != NULL) {
		Alteration* _tmp1_;
		Alteration* _tmp2_;
		_tmp1_ = alteration;
		_tmp2_ = alteration_compress (_tmp1_, additional_alteration);
		_alteration_unref0 (alteration);
		alteration = _tmp2_;
	}
	_tmp3_ = alteration;
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp3_);
	_alteration_unref0 (alteration);
}

guint64
video_add_flags (Video* self,
                 guint64 flags_to_add,
                 Alteration* additional_alteration)
{
	guint64 new_flags = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	g_return_val_if_fail (IS_VIDEO (self), 0ULL);
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			VideoRow* _tmp2_;
			VideoRow* _tmp14_;
			_tmp1_ = self->priv->backing_row;
			new_flags = media_source_internal_add_flags (_tmp1_->flags, flags_to_add);
			_tmp2_ = self->priv->backing_row;
			if (_tmp2_->flags == new_flags) {
				VideoRow* _tmp3_;
				_tmp3_ = self->priv->backing_row;
				result = _tmp3_->flags;
				{
					VideoRow* _tmp4_;
					_tmp4_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				return result;
			}
			{
				VideoTable* _tmp5_;
				VideoTable* _tmp6_;
				VideoID _tmp7_ = {0};
				_tmp5_ = video_table_get_instance ();
				_tmp6_ = _tmp5_;
				video_get_video_id (self, &_tmp7_);
				video_table_set_flags (_tmp6_, &_tmp7_, new_flags, &_inner_error0_);
				_database_table_unref0 (_tmp6_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					guint64 _tmp9_ = 0ULL;
					if (_inner_error0_->domain == DATABASE_ERROR) {
						goto __catch548_database_error;
					}
					{
						VideoRow* _tmp8_;
						_tmp8_ = self->priv->backing_row;
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp9_;
				}
			}
			goto __finally548;
			__catch548_database_error:
			{
				GError* e = NULL;
				GError* _tmp10_;
				VideoRow* _tmp11_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp10_ = e;
				app_window_database_error (_tmp10_);
				_tmp11_ = self->priv->backing_row;
				result = _tmp11_->flags;
				_g_error_free0 (e);
				{
					VideoRow* _tmp12_;
					_tmp12_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				return result;
			}
			__finally548:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				guint64 _tmp13_ = 0ULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp13_;
			}
			_tmp14_ = self->priv->backing_row;
			_tmp14_->flags = new_flags;
		}
		__finally547:
		{
			VideoRow* _tmp15_;
			_tmp15_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			guint64 _tmp16_ = 0ULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp16_;
		}
	}
	video_notify_flags_altered (self, additional_alteration);
	result = new_flags;
	return result;
}

guint64
video_remove_flags (Video* self,
                    guint64 flags_to_remove,
                    Alteration* additional_alteration)
{
	guint64 new_flags = 0ULL;
	GError* _inner_error0_ = NULL;
	guint64 result = 0ULL;
	g_return_val_if_fail (IS_VIDEO (self), 0ULL);
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
	{
		VideoRow* _tmp0_;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			VideoRow* _tmp2_;
			VideoRow* _tmp14_;
			_tmp1_ = self->priv->backing_row;
			new_flags = media_source_internal_remove_flags (_tmp1_->flags, flags_to_remove);
			_tmp2_ = self->priv->backing_row;
			if (_tmp2_->flags == new_flags) {
				VideoRow* _tmp3_;
				_tmp3_ = self->priv->backing_row;
				result = _tmp3_->flags;
				{
					VideoRow* _tmp4_;
					_tmp4_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				return result;
			}
			{
				VideoTable* _tmp5_;
				VideoTable* _tmp6_;
				VideoID _tmp7_ = {0};
				_tmp5_ = video_table_get_instance ();
				_tmp6_ = _tmp5_;
				video_get_video_id (self, &_tmp7_);
				video_table_set_flags (_tmp6_, &_tmp7_, new_flags, &_inner_error0_);
				_database_table_unref0 (_tmp6_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					guint64 _tmp9_ = 0ULL;
					if (_inner_error0_->domain == DATABASE_ERROR) {
						goto __catch550_database_error;
					}
					{
						VideoRow* _tmp8_;
						_tmp8_ = self->priv->backing_row;
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
					}
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp9_;
				}
			}
			goto __finally550;
			__catch550_database_error:
			{
				GError* e = NULL;
				GError* _tmp10_;
				VideoRow* _tmp11_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp10_ = e;
				app_window_database_error (_tmp10_);
				_tmp11_ = self->priv->backing_row;
				result = _tmp11_->flags;
				_g_error_free0 (e);
				{
					VideoRow* _tmp12_;
					_tmp12_ = self->priv->backing_row;
					g_rec_mutex_unlock (&self->priv->__lock_backing_row);
				}
				return result;
			}
			__finally550:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				guint64 _tmp13_ = 0ULL;
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return _tmp13_;
			}
			_tmp14_ = self->priv->backing_row;
			_tmp14_->flags = new_flags;
		}
		__finally549:
		{
			VideoRow* _tmp15_;
			_tmp15_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			guint64 _tmp16_ = 0ULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return _tmp16_;
		}
	}
	video_notify_flags_altered (self, additional_alteration);
	result = new_flags;
	return result;
}

gboolean
video_is_flag_set (Video* self,
                   guint64 flag)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIDEO (self), FALSE);
	{
		VideoRow* _tmp0_;
		gboolean _tmp4_ = FALSE;
		_tmp0_ = self->priv->backing_row;
		g_rec_mutex_lock (&self->priv->__lock_backing_row);
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			result = media_source_internal_is_flag_set (_tmp1_->flags, flag);
			{
				VideoRow* _tmp2_;
				_tmp2_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			return result;
		}
		__finally551:
		{
			VideoRow* _tmp3_;
			_tmp3_ = self->priv->backing_row;
			g_rec_mutex_unlock (&self->priv->__lock_backing_row);
		}
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp4_;
	}
}

static void
video_real_set_master_file (Monitorable* base,
                            GFile* file)
{
	Video * self;
	gchar* new_filepath = NULL;
	gchar* _tmp0_;
	gchar* old_filepath = NULL;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	GFile* _tmp21_;
	GFile* _tmp22_;
	Alteration* _tmp23_;
	Alteration* _tmp24_;
	GError* _inner_error0_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO, Video);
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
	_tmp0_ = g_file_get_path (file);
	new_filepath = _tmp0_;
	old_filepath = NULL;
	{
		{
			VideoRow* _tmp1_;
			_tmp1_ = self->priv->backing_row;
			g_rec_mutex_lock (&self->priv->__lock_backing_row);
			{
				VideoRow* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				VideoRow* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				VideoTable* _tmp9_;
				VideoTable* _tmp10_;
				VideoRow* _tmp11_;
				VideoID _tmp12_;
				const gchar* _tmp13_;
				VideoRow* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				_tmp2_ = self->priv->backing_row;
				_tmp3_ = _tmp2_->filepath;
				_tmp4_ = new_filepath;
				if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
					{
						GError* _inner_error0_ = NULL;
						VideoRow* _tmp5_;
						_tmp5_ = self->priv->backing_row;
						g_rec_mutex_unlock (&self->priv->__lock_backing_row);
					}
					_g_free0 (old_filepath);
					_g_free0 (new_filepath);
					return;
				}
				_tmp6_ = self->priv->backing_row;
				_tmp7_ = _tmp6_->filepath;
				_tmp8_ = g_strdup (_tmp7_);
				_g_free0 (old_filepath);
				old_filepath = _tmp8_;
				_tmp9_ = video_table_get_instance ();
				_tmp10_ = _tmp9_;
				_tmp11_ = self->priv->backing_row;
				_tmp12_ = _tmp11_->video_id;
				_tmp13_ = new_filepath;
				video_table_set_filepath (_tmp10_, &_tmp12_, _tmp13_, &_inner_error0_);
				_database_table_unref0 (_tmp10_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __finally553;
				}
				_tmp14_ = self->priv->backing_row;
				_tmp15_ = new_filepath;
				_tmp16_ = g_strdup (_tmp15_);
				_g_free0 (_tmp14_->filepath);
				_tmp14_->filepath = _tmp16_;
			}
			__finally553:
			{
				GError* _inner_error1_ = NULL;
				VideoRow* _tmp17_;
				_tmp17_ = self->priv->backing_row;
				g_rec_mutex_unlock (&self->priv->__lock_backing_row);
			}
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == DATABASE_ERROR) {
					goto __catch552_database_error;
				}
				_g_free0 (old_filepath);
				_g_free0 (new_filepath);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	goto __finally552;
	__catch552_database_error:
	{
		GError* err = NULL;
		GError* _tmp18_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp18_ = err;
		app_window_database_error (_tmp18_);
		_g_error_free0 (err);
		_g_free0 (old_filepath);
		_g_free0 (new_filepath);
		return;
	}
	__finally552:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (old_filepath);
		_g_free0 (new_filepath);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp19_ = old_filepath;
	_vala_assert (_tmp19_ != NULL, "old_filepath != null");
	_tmp20_ = old_filepath;
	_tmp21_ = g_file_new_for_path (_tmp20_);
	_tmp22_ = _tmp21_;
	media_source_notify_master_replaced (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource), _tmp22_, file);
	_g_object_unref0 (_tmp22_);
	_tmp23_ = alteration_new_from_list ("backing:master,metadata:name");
	_tmp24_ = _tmp23_;
	data_object_notify_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_OBJECT, DataObject), _tmp24_);
	_alteration_unref0 (_tmp24_);
	_g_free0 (old_filepath);
	_g_free0 (new_filepath);
}

VideoMetadata*
video_read_metadata (Video* self,
                     GError** error)
{
	VideoMetadata* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	VideoReader* _tmp3_;
	VideoReader* _tmp4_;
	VideoMetadata* _tmp5_;
	VideoMetadata* _tmp6_;
	VideoMetadata* _tmp7_;
	GError* _inner_error0_ = NULL;
	VideoMetadata* result = NULL;
	g_return_val_if_fail (IS_VIDEO (self), NULL);
	_tmp1_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE, MediaSource));
	_tmp2_ = _tmp1_;
	_tmp3_ = video_reader_new (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = video_reader_read_metadata (_tmp4_, &_inner_error0_);
	_tmp6_ = _tmp5_;
	_video_reader_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	_tmp0_ = _tmp6_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_propagate_error (error, _inner_error0_);
		return NULL;
	}
	_tmp7_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp7_;
	_media_metadata_unref0 (_tmp0_);
	return result;
}

VideoInterpretableResults*
video_interpretable_results_construct (GType object_type,
                                       Video* video)
{
	VideoInterpretableResults* self = NULL;
	Video* _tmp0_;
	g_return_val_if_fail (IS_VIDEO (video), NULL);
	self = (VideoInterpretableResults*) g_type_create_instance (object_type);
	_tmp0_ = _g_object_ref0 (video);
	_g_object_unref0 (self->video);
	self->video = _tmp0_;
	return self;
}

VideoInterpretableResults*
video_interpretable_results_new (Video* video)
{
	return video_interpretable_results_construct (VIDEO_TYPE_INTERPRETABLE_RESULTS, video);
}

void
video_interpretable_results_foreground_finish (VideoInterpretableResults* self)
{
	GdkPixbuf* _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (VIDEO_IS_INTERPRETABLE_RESULTS (self));
	if (self->update_interpretable) {
		Video* _tmp0_;
		_tmp0_ = self->video;
		video_set_is_interpretable (_tmp0_, self->is_interpretable);
	}
	_tmp1_ = self->new_thumbnail;
	if (_tmp1_ != NULL) {
		{
			Video* _tmp2_;
			GdkPixbuf* _tmp3_;
			Video* _tmp4_;
			GdkPixbuf* _tmp5_;
			Video* _tmp6_;
			_tmp2_ = self->video;
			_tmp3_ = self->new_thumbnail;
			thumbnail_cache_replace (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), THUMBNAIL_CACHE_SIZE_BIG, _tmp3_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch554_g_error;
			}
			_tmp4_ = self->video;
			_tmp5_ = self->new_thumbnail;
			thumbnail_cache_replace (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), THUMBNAIL_CACHE_SIZE_MEDIUM, _tmp5_, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch554_g_error;
			}
			_tmp6_ = self->video;
			thumbnail_source_notify_thumbnail_altered (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource));
		}
		goto __finally554;
		__catch554_g_error:
		{
			GError* err = NULL;
			Video* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			GError* _tmp10_;
			const gchar* _tmp11_;
			err = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp7_ = self->video;
			_tmp8_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_OBJECT, DataObject));
			_tmp9_ = _tmp8_;
			_tmp10_ = err;
			_tmp11_ = _tmp10_->message;
			g_message ("VideoSupport.vala:355: Unable to update video thumbnails for %s: %s", _tmp9_, _tmp11_);
			_g_free0 (_tmp9_);
			_g_error_free0 (err);
		}
		__finally554:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
}

static void
video_value_interpretable_results_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
video_value_interpretable_results_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		video_interpretable_results_unref (value->data[0].v_pointer);
	}
}

static void
video_value_interpretable_results_copy_value (const GValue* src_value,
                                              GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = video_interpretable_results_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
video_value_interpretable_results_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
video_value_interpretable_results_collect_value (GValue* value,
                                                 guint n_collect_values,
                                                 GTypeCValue* collect_values,
                                                 guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		VideoInterpretableResults * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = video_interpretable_results_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
video_value_interpretable_results_lcopy_value (const GValue* value,
                                               guint n_collect_values,
                                               GTypeCValue* collect_values,
                                               guint collect_flags)
{
	VideoInterpretableResults ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = video_interpretable_results_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
video_param_spec_interpretable_results (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags)
{
	VideoParamSpecInterpretableResults* spec;
	g_return_val_if_fail (g_type_is_a (object_type, VIDEO_TYPE_INTERPRETABLE_RESULTS), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
video_value_get_interpretable_results (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIDEO_TYPE_INTERPRETABLE_RESULTS), NULL);
	return value->data[0].v_pointer;
}

void
video_value_set_interpretable_results (GValue* value,
                                       gpointer v_object)
{
	VideoInterpretableResults * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIDEO_TYPE_INTERPRETABLE_RESULTS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIDEO_TYPE_INTERPRETABLE_RESULTS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		video_interpretable_results_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		video_interpretable_results_unref (old);
	}
}

void
video_value_take_interpretable_results (GValue* value,
                                        gpointer v_object)
{
	VideoInterpretableResults * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIDEO_TYPE_INTERPRETABLE_RESULTS));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIDEO_TYPE_INTERPRETABLE_RESULTS));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		video_interpretable_results_unref (old);
	}
}

static void
video_interpretable_results_class_init (VideoInterpretableResultsClass * klass,
                                        gpointer klass_data)
{
	video_interpretable_results_parent_class = g_type_class_peek_parent (klass);
	((VideoInterpretableResultsClass *) klass)->finalize = video_interpretable_results_finalize;
}

static void
video_interpretable_results_instance_init (VideoInterpretableResults * self,
                                           gpointer klass)
{
	self->update_interpretable = FALSE;
	self->is_interpretable = FALSE;
	self->new_thumbnail = NULL;
	self->ref_count = 1;
}

static void
video_interpretable_results_finalize (VideoInterpretableResults * obj)
{
	VideoInterpretableResults * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIDEO_TYPE_INTERPRETABLE_RESULTS, VideoInterpretableResults);
	g_signal_handlers_destroy (self);
	_g_object_unref0 (self->video);
	_g_object_unref0 (self->new_thumbnail);
}

GType
video_interpretable_results_get_type (void)
{
	static volatile gsize video_interpretable_results_type_id__volatile = 0;
	if (g_once_init_enter (&video_interpretable_results_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { video_value_interpretable_results_init, video_value_interpretable_results_free_value, video_value_interpretable_results_copy_value, video_value_interpretable_results_peek_pointer, "p", video_value_interpretable_results_collect_value, "p", video_value_interpretable_results_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (VideoInterpretableResultsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_interpretable_results_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoInterpretableResults), 0, (GInstanceInitFunc) video_interpretable_results_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType video_interpretable_results_type_id;
		video_interpretable_results_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VideoInterpretableResults", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&video_interpretable_results_type_id__volatile, video_interpretable_results_type_id);
	}
	return video_interpretable_results_type_id__volatile;
}

gpointer
video_interpretable_results_ref (gpointer instance)
{
	VideoInterpretableResults * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
video_interpretable_results_unref (gpointer instance)
{
	VideoInterpretableResults * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VIDEO_INTERPRETABLE_RESULTS_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static void
video_class_init (VideoClass * klass,
                  gpointer klass_data)
{
	video_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Video_private_offset);
	((DataSourceClass *) klass)->commit_backlinks = (void (*) (DataSource*, SourceCollection*, const gchar*)) video_real_commit_backlinks;
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*) (MediaSource*, EventID*)) video_real_set_event_id;
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*) (MediaSource*, gint*)) video_real_get_backing_files_state;
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) video_real_get_thumbnail;
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*) (MediaSource*)) video_real_get_master_md5;
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*) (MediaSource*, Scaling*, GError**)) video_real_get_preview_pixbuf;
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*) (ThumbnailSource*, gint, GError**)) video_real_create_thumbnail;
	((DataSourceClass *) klass)->get_typename = (gchar* (*) (DataSource*)) video_real_get_typename;
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*) (DataSource*)) video_real_get_instance_id;
	((MediaSourceClass *) klass)->get_import_id = (void (*) (MediaSource*, ImportID*)) video_real_get_import_id;
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*) (ThumbnailSource*)) video_real_get_preferred_thumbnail_format;
	((MediaSourceClass *) klass)->get_title = (gchar* (*) (MediaSource*)) video_real_get_title;
	((MediaSourceClass *) klass)->set_title = (void (*) (MediaSource*, const gchar*)) video_real_set_title;
	((MediaSourceClass *) klass)->get_comment = (gchar* (*) (MediaSource*)) video_real_get_comment;
	((MediaSourceClass *) klass)->set_comment = (gboolean (*) (MediaSource*, const gchar*)) video_real_set_comment;
	((MediaSourceClass *) klass)->get_rating = (Rating (*) (MediaSource*)) video_real_get_rating;
	((MediaSourceClass *) klass)->set_rating = (void (*) (MediaSource*, Rating)) video_real_set_rating;
	((MediaSourceClass *) klass)->increase_rating = (void (*) (MediaSource*)) video_real_increase_rating;
	((MediaSourceClass *) klass)->decrease_rating = (void (*) (MediaSource*)) video_real_decrease_rating;
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*) (MediaSource*)) video_real_is_trashed;
	((MediaSourceClass *) klass)->is_offline = (gboolean (*) (MediaSource*)) video_real_is_offline;
	((MediaSourceClass *) klass)->mark_offline = (void (*) (MediaSource*)) video_real_mark_offline;
	((MediaSourceClass *) klass)->mark_online = (void (*) (MediaSource*)) video_real_mark_online;
	((MediaSourceClass *) klass)->trash = (void (*) (MediaSource*)) video_real_trash;
	((MediaSourceClass *) klass)->untrash = (void (*) (MediaSource*)) video_real_untrash;
	((MediaSourceClass *) klass)->get_event_id = (void (*) (MediaSource*, EventID*)) video_real_get_event_id;
	((DataObjectClass *) klass)->to_string = (gchar* (*) (DataObject*)) video_real_to_string;
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*) (MediaSource*)) video_real_get_exposure_time;
	((MediaSourceClass *) klass)->get_dimensions = (void (*) (MediaSource*, PhotoException, Dimensions*)) video_real_get_dimensions;
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*) (MediaSource*)) video_real_get_filesize;
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*) (MediaSource*)) video_real_get_master_filesize;
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*) (MediaSource*)) video_real_get_timestamp;
	((MediaSourceClass *) klass)->get_file = (GFile* (*) (MediaSource*)) video_real_get_file;
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*) (MediaSource*)) video_real_get_master_file;
	((DataSourceClass *) klass)->destroy = (void (*) (DataSource*)) video_real_destroy;
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*) (DataSource*, GError**)) video_real_internal_delete_backing;
	G_OBJECT_CLASS (klass)->finalize = video_finalize;
}

static void
video_flaggable_interface_init (FlaggableIface * iface,
                                gpointer iface_data)
{
	video_flaggable_parent_iface = g_type_interface_peek_parent (iface);
	iface->is_flagged = (gboolean (*) (Flaggable*)) video_real_is_flagged;
	iface->mark_flagged = (void (*) (Flaggable*)) video_real_mark_flagged;
	iface->mark_unflagged = (void (*) (Flaggable*)) video_real_mark_unflagged;
}

static void
video_monitorable_interface_init (MonitorableIface * iface,
                                  gpointer iface_data)
{
	video_monitorable_parent_iface = g_type_interface_peek_parent (iface);
	iface->is_offline = (gboolean (*) (Monitorable*)) video_real_is_offline;
	iface->mark_offline = (void (*) (Monitorable*)) video_real_mark_offline;
	iface->mark_online = (void (*) (Monitorable*)) video_real_mark_online;
	iface->set_master_timestamp = (void (*) (Monitorable*, GFileInfo*)) video_real_set_master_timestamp;
	iface->set_master_file = (void (*) (Monitorable*, GFile*)) video_real_set_master_file;
}

static void
video_dateable_interface_init (DateableIface * iface,
                               gpointer iface_data)
{
	video_dateable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_exposure_time = (time_t (*) (Dateable*)) video_real_get_exposure_time;
	iface->set_exposure_time = (void (*) (Dateable*, time_t)) video_real_set_exposure_time;
}

static void
video_instance_init (Video * self,
                     gpointer klass)
{
	self->priv = video_get_instance_private (self);
	g_rec_mutex_init (&self->priv->__lock_backing_row);
}

static void
video_finalize (GObject * obj)
{
	Video * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO, Video);
	g_rec_mutex_clear (&self->priv->__lock_backing_row);
	_video_row_unref0 (self->priv->backing_row);
	G_OBJECT_CLASS (video_parent_class)->finalize (obj);
}

GType
video_get_type (void)
{
	static volatile gsize video_type_id__volatile = 0;
	if (g_once_init_enter (&video_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Video), 0, (GInstanceInitFunc) video_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) video_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) video_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) video_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType video_type_id;
		video_type_id = g_type_register_static (TYPE_VIDEO_SOURCE, "Video", &g_define_type_info, 0);
		g_type_add_interface_static (video_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (video_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_type_add_interface_static (video_type_id, TYPE_DATEABLE, &dateable_info);
		Video_private_offset = g_type_add_instance_private (video_type_id, sizeof (VideoPrivate));
		g_once_init_leave (&video_type_id__volatile, video_type_id);
	}
	return video_type_id__volatile;
}

static inline gpointer
video_source_collection_get_instance_private (VideoSourceCollection* self)
{
	return G_STRUCT_MEMBER_P (self, VideoSourceCollection_private_offset);
}

GType
video_source_collection_state_get_type (void)
{
	static volatile gsize video_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&video_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN, "VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {VIDEO_SOURCE_COLLECTION_STATE_ONLINE, "VIDEO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {VIDEO_SOURCE_COLLECTION_STATE_OFFLINE, "VIDEO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {VIDEO_SOURCE_COLLECTION_STATE_TRASH, "VIDEO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {0, NULL, NULL}};
		GType video_source_collection_state_type_id;
		video_source_collection_state_type_id = g_enum_register_static ("VideoSourceCollectionState", values);
		g_once_init_leave (&video_source_collection_state_type_id__volatile, video_source_collection_state_type_id);
	}
	return video_source_collection_state_type_id__volatile;
}

static gint
_uint64_compare_gcompare_data_func (gconstpointer a,
                                    gconstpointer b,
                                    gpointer self)
{
	gint result;
	result = uint64_compare ((guint64*) a, (guint64*) b);
	return result;
}

static guint64*
_uint64_dup (guint64* self)
{
	guint64* dup;
	dup = g_new0 (guint64, 1);
	memcpy (dup, self, sizeof (guint64));
	return dup;
}

static gint64
_video_source_collection_get_video_key_get_source_database_key (DataSource* source,
                                                                gpointer self)
{
	gint64 result;
	result = video_source_collection_get_video_key (source);
	return result;
}

static void
_video_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                            GeeCollection* added,
                                                                                            GeeCollection* removed,
                                                                                            gpointer self)
{
	video_source_collection_on_trashcan_contents_altered ((VideoSourceCollection*) self, added, removed);
}

static void
_video_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender,
                                                                                           GeeCollection* added,
                                                                                           GeeCollection* removed,
                                                                                           gpointer self)
{
	video_source_collection_on_offline_contents_altered ((VideoSourceCollection*) self, added, removed);
}

VideoSourceCollection*
video_source_collection_construct (GType object_type)
{
	VideoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	self = (VideoSourceCollection*) media_source_collection_construct (object_type, "VideoSourceCollection", _video_source_collection_get_video_key_get_source_database_key, NULL);
	_tmp0_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
	_tmp1_ = _tmp0_;
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _video_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
	_source_holding_tank_unref0 (_tmp1_);
	_tmp2_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
	_tmp3_ = _tmp2_;
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank), "contents-altered", (GCallback) _video_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
	_source_holding_tank_unref0 (_tmp3_);
	return self;
}

VideoSourceCollection*
video_source_collection_new (void)
{
	return video_source_collection_construct (TYPE_VIDEO_SOURCE_COLLECTION);
}

static gboolean
_video_source_collection_is_video_trashed_source_holding_tank_check_to_keep (DataSource* source,
                                                                             Alteration* alteration,
                                                                             gpointer self)
{
	gboolean result;
	result = video_source_collection_is_video_trashed (source);
	return result;
}

static MediaSourceHoldingTank*
video_source_collection_real_create_trashcan (MediaSourceCollection* base)
{
	VideoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	_tmp0_ = media_source_holding_tank_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _video_source_collection_is_video_trashed_source_holding_tank_check_to_keep, NULL, _video_source_collection_get_video_key_get_source_database_key, NULL);
	result = _tmp0_;
	return result;
}

static gboolean
_video_source_collection_is_video_offline_source_holding_tank_check_to_keep (DataSource* source,
                                                                             Alteration* alteration,
                                                                             gpointer self)
{
	gboolean result;
	result = video_source_collection_is_video_offline (source);
	return result;
}

static MediaSourceHoldingTank*
video_source_collection_real_create_offline_bin (MediaSourceCollection* base)
{
	VideoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_;
	MediaSourceHoldingTank* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	_tmp0_ = media_source_holding_tank_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _video_source_collection_is_video_offline_source_holding_tank_check_to_keep, NULL, _video_source_collection_get_video_key_get_source_database_key, NULL);
	result = _tmp0_;
	return result;
}

static MediaMonitor*
video_source_collection_real_create_media_monitor (MediaSourceCollection* base,
                                                   Workers* workers,
                                                   GCancellable* cancellable)
{
	VideoSourceCollection * self;
	VideoMonitor* _tmp0_;
	MediaMonitor* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
	_tmp0_ = video_monitor_new (cancellable);
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_MEDIA_MONITOR, MediaMonitor);
	return result;
}

static gboolean
video_source_collection_real_holds_type_of_source (SourceCollection* base,
                                                   DataSource* source)
{
	VideoSourceCollection * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	result = IS_VIDEO (source);
	return result;
}

static gchar*
video_source_collection_real_get_typename (MediaSourceCollection* base)
{
	VideoSourceCollection * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	_tmp0_ = g_strdup (VIDEO_TYPENAME);
	result = _tmp0_;
	return result;
}

static gboolean
video_source_collection_real_is_file_recognized (MediaSourceCollection* base,
                                                 GFile* file)
{
	VideoSourceCollection * self;
	gboolean result = FALSE;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
	result = video_reader_is_supported_video_file (file);
	return result;
}

static void
video_source_collection_on_trashcan_contents_altered (VideoSourceCollection* self,
                                                      GeeCollection* added,
                                                      GeeCollection* removed)
{
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
}

static void
video_source_collection_on_offline_contents_altered (VideoSourceCollection* self,
                                                     GeeCollection* added,
                                                     GeeCollection* removed)
{
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_COLLECTION));
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_COLLECTION));
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (added, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (removed, GEE_TYPE_COLLECTION, GeeCollection));
}

static MediaSource*
video_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base,
                                                  gint64 numeric_id)
{
	VideoSourceCollection * self;
	VideoID _tmp0_ = {0};
	Video* _tmp1_;
	MediaSource* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	video_id_init (&_tmp0_, numeric_id);
	_tmp1_ = video_source_collection_fetch (self, &_tmp0_);
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource);
	return result;
}

gint64
video_source_collection_get_video_key (DataSource* source)
{
	Video* video = NULL;
	Video* _tmp0_;
	VideoID video_id = {0};
	VideoID _tmp1_ = {0};
	VideoID _tmp2_;
	gint64 result = 0LL;
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_VIDEO, Video));
	video = _tmp0_;
	video_get_video_id (video, &_tmp1_);
	video_id = _tmp1_;
	_tmp2_ = video_id;
	result = _tmp2_.id;
	_g_object_unref0 (video);
	return result;
}

gboolean
video_source_collection_is_video_trashed (DataSource* source)
{
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	result = media_source_is_trashed (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_VIDEO, Video), TYPE_MEDIA_SOURCE, MediaSource));
	return result;
}

gboolean
video_source_collection_is_video_offline (DataSource* source)
{
	gboolean result = FALSE;
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
	result = media_source_is_offline (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (source, TYPE_VIDEO, Video), TYPE_MEDIA_SOURCE, MediaSource));
	return result;
}

Video*
video_source_collection_fetch (VideoSourceCollection* self,
                               VideoID* video_id)
{
	VideoID _tmp0_;
	DataSource* _tmp1_;
	Video* result = NULL;
	g_return_val_if_fail (IS_VIDEO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (video_id != NULL, NULL);
	_tmp0_ = *video_id;
	_tmp1_ = database_source_collection_fetch_by_key (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection), _tmp0_.id);
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_VIDEO, Video);
	return result;
}

static GeeCollection*
video_source_collection_real_get_event_source_ids (MediaSourceCollection* base,
                                                   EventID* event_id)
{
	VideoSourceCollection * self;
	VideoTable* _tmp0_;
	VideoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* result = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	g_return_val_if_fail (event_id != NULL, NULL);
	_tmp0_ = video_table_get_instance ();
	_tmp1_ = _tmp0_;
	_tmp2_ = *event_id;
	_tmp3_ = video_table_get_event_source_ids (_tmp1_, &_tmp2_);
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
	_database_table_unref0 (_tmp1_);
	result = _tmp4_;
	return result;
}

Video*
video_source_collection_get_state_by_file (VideoSourceCollection* self,
                                           GFile* file,
                                           VideoSourceCollectionState* state)
{
	VideoSourceCollectionState _vala_state = 0;
	Video* video = NULL;
	MediaSource* _tmp0_;
	Video* _tmp1_;
	MediaSourceHoldingTank* _tmp2_;
	MediaSourceHoldingTank* _tmp3_;
	MediaSource* _tmp4_;
	Video* _tmp5_;
	MediaSourceHoldingTank* _tmp6_;
	MediaSourceHoldingTank* _tmp7_;
	MediaSource* _tmp8_;
	Video* _tmp9_;
	Video* result = NULL;
	g_return_val_if_fail (IS_VIDEO_SOURCE_COLLECTION (self), NULL);
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
	_tmp0_ = media_source_collection_fetch_by_master_file (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), file);
	video = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_VIDEO, Video);
	_tmp1_ = video;
	if (_tmp1_ != NULL) {
		_vala_state = VIDEO_SOURCE_COLLECTION_STATE_ONLINE;
		result = video;
		if (state) {
			*state = _vala_state;
		}
		return result;
	}
	_tmp2_ = media_source_collection_get_trashcan (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
	_tmp3_ = _tmp2_;
	_tmp4_ = media_source_holding_tank_fetch_by_master_file (_tmp3_, file);
	_g_object_unref0 (video);
	video = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_VIDEO, Video);
	_source_holding_tank_unref0 (_tmp3_);
	_tmp5_ = video;
	if (_tmp5_ != NULL) {
		_vala_state = VIDEO_SOURCE_COLLECTION_STATE_TRASH;
		result = video;
		if (state) {
			*state = _vala_state;
		}
		return result;
	}
	_tmp6_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
	_tmp7_ = _tmp6_;
	_tmp8_ = media_source_holding_tank_fetch_by_master_file (_tmp7_, file);
	_g_object_unref0 (video);
	video = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_VIDEO, Video);
	_source_holding_tank_unref0 (_tmp7_);
	_tmp9_ = video;
	if (_tmp9_ != NULL) {
		_vala_state = VIDEO_SOURCE_COLLECTION_STATE_OFFLINE;
		result = video;
		if (state) {
			*state = _vala_state;
		}
		return result;
	}
	_vala_state = VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN;
	result = NULL;
	_g_object_unref0 (video);
	if (state) {
		*state = _vala_state;
	}
	return result;
}

static void
video_source_collection_compare_backing (VideoSourceCollection* self,
                                         Video* video,
                                         GFileInfo* info,
                                         GeeCollection* matching_master)
{
	GTimeVal _tmp0_ = {0};
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
	g_return_if_fail (IS_VIDEO (video));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matching_master, GEE_TYPE_COLLECTION));
	if (media_source_get_filesize (G_TYPE_CHECK_INSTANCE_CAST (video, TYPE_MEDIA_SOURCE, MediaSource)) != ((guint64) g_file_info_get_size (info))) {
		return;
	}
	g_file_info_get_modification_time (info, &_tmp0_);
	if (media_source_get_timestamp (G_TYPE_CHECK_INSTANCE_CAST (video, TYPE_MEDIA_SOURCE, MediaSource)) == ((time_t) _tmp0_.tv_sec)) {
		gee_collection_add (matching_master, video);
	}
}

void
video_source_collection_fetch_by_matching_backing (VideoSourceCollection* self,
                                                   GFileInfo* info,
                                                   GeeCollection* matching_master)
{
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (matching_master, GEE_TYPE_COLLECTION));
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
		_tmp0_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
		_tmp1_ = _tmp0_;
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
		_tmp3_ = _tmp2_;
		_g_object_unref0 (_tmp1_);
		_object_it = _tmp3_;
		while (TRUE) {
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataObject* _tmp7_;
			_tmp4_ = _object_it;
			if (!gee_iterator_next (_tmp4_)) {
				break;
			}
			_tmp5_ = _object_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			object = (DataObject*) _tmp6_;
			_tmp7_ = object;
			video_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_VIDEO, Video), info, matching_master);
			_g_object_unref0 (object);
		}
		_g_object_unref0 (_object_it);
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeIterator* _tmp10_;
		GeeIterator* _tmp11_;
		_tmp8_ = media_source_collection_get_offline_bin_contents (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
		_tmp9_ = _tmp8_;
		_tmp10_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ITERABLE, GeeIterable));
		_tmp11_ = _tmp10_;
		_g_object_unref0 (_tmp9_);
		_media_it = _tmp11_;
		while (TRUE) {
			GeeIterator* _tmp12_;
			MediaSource* media = NULL;
			GeeIterator* _tmp13_;
			gpointer _tmp14_;
			MediaSource* _tmp15_;
			_tmp12_ = _media_it;
			if (!gee_iterator_next (_tmp12_)) {
				break;
			}
			_tmp13_ = _media_it;
			_tmp14_ = gee_iterator_get (_tmp13_);
			media = (MediaSource*) _tmp14_;
			_tmp15_ = media;
			video_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_VIDEO, Video), info, matching_master);
			_g_object_unref0 (media);
		}
		_g_object_unref0 (_media_it);
	}
}

static void
video_source_collection_real_notify_contents_altered (DataCollection* base,
                                                      GeeIterable* added,
                                                      GeeIterable* removed)
{
	VideoSourceCollection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	g_return_if_fail ((added == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
	g_return_if_fail ((removed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_ITERABLE));
	if (added != NULL) {
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp0_;
			_tmp0_ = gee_iterable_iterator (added);
			_object_it = _tmp0_;
			while (TRUE) {
				GeeIterator* _tmp1_;
				DataObject* object = NULL;
				GeeIterator* _tmp2_;
				gpointer _tmp3_;
				Video* video = NULL;
				DataObject* _tmp4_;
				Video* _tmp5_;
				GeeMultiMap* _tmp6_;
				Video* _tmp7_;
				guint64 _tmp8_;
				Video* _tmp9_;
				_tmp1_ = _object_it;
				if (!gee_iterator_next (_tmp1_)) {
					break;
				}
				_tmp2_ = _object_it;
				_tmp3_ = gee_iterator_get (_tmp2_);
				object = (DataObject*) _tmp3_;
				_tmp4_ = object;
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_VIDEO, Video));
				video = _tmp5_;
				_tmp6_ = self->priv->filesize_to_video;
				_tmp7_ = video;
				_tmp8_ = media_source_get_master_filesize (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_MEDIA_SOURCE, MediaSource));
				_tmp9_ = video;
				gee_multi_map_set (_tmp6_, &_tmp8_, _tmp9_);
				_g_object_unref0 (video);
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
	if (removed != NULL) {
		{
			GeeIterator* _object_it = NULL;
			GeeIterator* _tmp10_;
			_tmp10_ = gee_iterable_iterator (removed);
			_object_it = _tmp10_;
			while (TRUE) {
				GeeIterator* _tmp11_;
				DataObject* object = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				Video* video = NULL;
				DataObject* _tmp14_;
				Video* _tmp15_;
				GeeMultiMap* _tmp16_;
				Video* _tmp17_;
				guint64 _tmp18_;
				Video* _tmp19_;
				_tmp11_ = _object_it;
				if (!gee_iterator_next (_tmp11_)) {
					break;
				}
				_tmp12_ = _object_it;
				_tmp13_ = gee_iterator_get (_tmp12_);
				object = (DataObject*) _tmp13_;
				_tmp14_ = object;
				_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_VIDEO, Video));
				video = _tmp15_;
				_tmp16_ = self->priv->filesize_to_video;
				_tmp17_ = video;
				_tmp18_ = media_source_get_master_filesize (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_MEDIA_SOURCE, MediaSource));
				_tmp19_ = video;
				gee_multi_map_remove (_tmp16_, &_tmp18_, _tmp19_);
				_g_object_unref0 (video);
				_g_object_unref0 (object);
			}
			_g_object_unref0 (_object_it);
		}
	}
	DATA_COLLECTION_CLASS (video_source_collection_parent_class)->notify_contents_altered (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), TYPE_DATA_COLLECTION, DataCollection), added, removed);
}

void
video_source_collection_get_basename_filesize_duplicate (VideoSourceCollection* self,
                                                         const gchar* basename,
                                                         guint64 filesize,
                                                         VideoID* result)
{
	VideoID _tmp15_ = {0};
	g_return_if_fail (IS_VIDEO_SOURCE_COLLECTION (self));
	g_return_if_fail (basename != NULL);
	{
		GeeIterator* _video_it = NULL;
		GeeMultiMap* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
		_tmp0_ = self->priv->filesize_to_video;
		_tmp1_ = gee_multi_map_get (_tmp0_, &filesize);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
		_tmp4_ = _tmp3_;
		_g_object_unref0 (_tmp2_);
		_video_it = _tmp4_;
		while (TRUE) {
			GeeIterator* _tmp5_;
			Video* video = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Video* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			gchar* _tmp11_;
			gboolean _tmp12_;
			_tmp5_ = _video_it;
			if (!gee_iterator_next (_tmp5_)) {
				break;
			}
			_tmp6_ = _video_it;
			_tmp7_ = gee_iterator_get (_tmp6_);
			video = (Video*) _tmp7_;
			_tmp8_ = video;
			_tmp9_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
			_tmp10_ = _tmp9_;
			_tmp11_ = g_file_get_basename (_tmp10_);
			_tmp12_ = utf8_ci_compare (_tmp11_, basename) == 0;
			_g_object_unref0 (_tmp10_);
			if (_tmp12_) {
				Video* _tmp13_;
				VideoID _tmp14_ = {0};
				_tmp13_ = video;
				video_get_video_id (_tmp13_, &_tmp14_);
				*result = _tmp14_;
				_g_object_unref0 (video);
				_g_object_unref0 (_video_it);
				return;
			}
			_g_object_unref0 (video);
		}
		_g_object_unref0 (_video_it);
	}
	video_id_init (&_tmp15_, VIDEO_ID_INVALID);
	*result = _tmp15_;
	return;
}

gboolean
video_source_collection_has_basename_filesize_duplicate (VideoSourceCollection* self,
                                                         const gchar* basename,
                                                         guint64 filesize)
{
	VideoID _tmp0_ = {0};
	gboolean result = FALSE;
	g_return_val_if_fail (IS_VIDEO_SOURCE_COLLECTION (self), FALSE);
	g_return_val_if_fail (basename != NULL, FALSE);
	video_source_collection_get_basename_filesize_duplicate (self, basename, filesize, &_tmp0_);
	result = video_id_is_valid (&_tmp0_);
	return result;
}

static TransactionController*
video_source_collection_real_get_transaction_controller (MediaSourceCollection* base)
{
	TransactionController* result;
	VideoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	_tmp0_ = self->priv->_transaction_controller;
	if (_tmp0_ == NULL) {
		MediaSourceTransactionController* _tmp1_;
		_tmp1_ = media_source_transaction_controller_new (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
		_transaction_controller_unref0 (self->priv->_transaction_controller);
		self->priv->_transaction_controller = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_TRANSACTION_CONTROLLER, TransactionController);
	}
	_tmp2_ = self->priv->_transaction_controller;
	result = _tmp2_;
	return result;
}

static void
video_source_collection_class_init (VideoSourceCollectionClass * klass,
                                    gpointer klass_data)
{
	video_source_collection_parent_class = g_type_class_peek_parent (klass);
	((DataCollectionClass *) klass)->finalize = video_source_collection_finalize;
	g_type_class_adjust_private_offset (klass, &VideoSourceCollection_private_offset);
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) video_source_collection_real_create_trashcan;
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*) (MediaSourceCollection*)) video_source_collection_real_create_offline_bin;
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*) (MediaSourceCollection*, Workers*, GCancellable*)) video_source_collection_real_create_media_monitor;
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*) (SourceCollection*, DataSource*)) video_source_collection_real_holds_type_of_source;
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*) (MediaSourceCollection*)) video_source_collection_real_get_typename;
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*) (MediaSourceCollection*, GFile*)) video_source_collection_real_is_file_recognized;
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*) (MediaSourceCollection*, gint64)) video_source_collection_real_fetch_by_numeric_id;
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*) (MediaSourceCollection*, EventID*)) video_source_collection_real_get_event_source_ids;
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*) (DataCollection*, GeeIterable*, GeeIterable*)) video_source_collection_real_notify_contents_altered;
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = video_source_collection_real_get_transaction_controller;
}

static void
video_source_collection_instance_init (VideoSourceCollection * self,
                                       gpointer klass)
{
	GeeTreeMultiMap* _tmp0_;
	self->priv = video_source_collection_get_instance_private (self);
	self->priv->_transaction_controller = NULL;
	_tmp0_ = gee_tree_multi_map_new (G_TYPE_UINT64, (GBoxedCopyFunc) _uint64_dup, (GDestroyNotify) g_free, TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _uint64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
	self->priv->filesize_to_video = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MULTI_MAP, GeeMultiMap);
}

static void
video_source_collection_finalize (DataCollection * obj)
{
	VideoSourceCollection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection);
	_transaction_controller_unref0 (self->priv->_transaction_controller);
	_g_object_unref0 (self->priv->filesize_to_video);
	DATA_COLLECTION_CLASS (video_source_collection_parent_class)->finalize (obj);
}

GType
video_source_collection_get_type (void)
{
	static volatile gsize video_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&video_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoSourceCollection), 0, (GInstanceInitFunc) video_source_collection_instance_init, NULL };
		GType video_source_collection_type_id;
		video_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "VideoSourceCollection", &g_define_type_info, 0);
		VideoSourceCollection_private_offset = g_type_add_instance_private (video_source_collection_type_id, sizeof (VideoSourceCollectionPrivate));
		g_once_init_leave (&video_source_collection_type_id__volatile, video_source_collection_type_id);
	}
	return video_source_collection_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

